Canvas Functions
Evas

Low level Evas canvas functions. More...

## Topics

| Render Engine Functions
| Functions that are used to set the render engine for a given function, and then get that engine working.
| Coordinate Mapping Functions
| Functions that are used to map coordinates from the canvas to the screen or the screen to the canvas.
| Output and Viewport Resizing Functions
| Functions that set and retrieve the output and viewport size of an evas.
| Canvas Events
| Functions relating to canvas events that report on changes of its internal states (an object got focused, the rendering is updated, etc).
| Image Functions
| Functions that deal with images at canvas level.
| Font Functions
| Functions that deal with fonts.
| Key Input Functions
| Functions that feed key events to the canvas.
| Rendering GL on Evas
| This group discusses the functions that are used to do OpenGL rendering on Evas.
| Touch Point List Functions
| Functions to get information of touched points in the Evas.

## Macros

#define | EVAS_CANVAS_CLASS evas_canvas_class_get()
| Evas canvas class.

## Typedefs

typedef Eo | Evas
| An opaque handle to an Evas canvas.
typedef struct _Evas_Public_Data | Evas_Public_Data
| Public data for an Evas.

## Functions

EVAS_API EVAS_API_WEAK void | evas_canvas_image_cache_set (Eo *obj, int size)
| Set the image cache.
EVAS_API EVAS_API_WEAK int | evas_canvas_image_cache_get (const Eo *obj)
| Get the image cache.
EVAS_API EVAS_API_WEAK void | evas_canvas_event_default_flags_set (Eo *obj, Evas_Event_Flags flags)
| Set the default set of flags an event begins with.
EVAS_API EVAS_API_WEAK Evas_Event_Flags | evas_canvas_event_default_flags_get (const Eo *obj)
| Get the default set of flags an event begins with.
EVAS_API EVAS_API_WEAK void | evas_canvas_font_cache_set (Eo *obj, int size)
| Changes the size of font cache of the given evas.
EVAS_API EVAS_API_WEAK int | evas_canvas_font_cache_get (const Eo *obj)
| Get the size of font cache of the given evas in bytes.
EVAS_API EVAS_API_WEAK void | evas_canvas_data_attach_set (Eo *obj, void *data)
| Attaches a specific pointer to the evas for fetching later.
EVAS_API EVAS_API_WEAK void * | evas_canvas_data_attach_get (const Eo *obj)
| Returns the pointer attached by evas_canvas_data_attach_set.
EVAS_API EVAS_API_WEAK Efl_Canvas_Object * | evas_canvas_focus_get (const Eo *obj)
| Retrieve the object focused by the default seat.
EVAS_API EVAS_API_WEAK Efl_Canvas_Object * | evas_canvas_seat_focus_get (const Eo *obj, Evas_Device *seat)
| Return the focused object by a given seat.
EVAS_API EVAS_API_WEAK Efl_Canvas_Object * | evas_canvas_object_top_get (const Eo *obj)
| Get the highest (stacked) Evas object on the canvas `e`.
EVAS_API EVAS_API_WEAK void | evas_canvas_pointer_canvas_xy_by_device_get (const Eo *obj, Evas_Device *dev, int *x, int *y)
| This function returns the current known default pointer coordinates.
EVAS_API EVAS_API_WEAK void | evas_canvas_pointer_canvas_xy_get (const Eo *obj, int *x, int *y)
| This function returns the current known default pointer coordinates.
EVAS_API EVAS_API_WEAK int | evas_canvas_event_down_count_get (const Eo *obj)
| Get the number of mouse or multi presses currently active.
EVAS_API EVAS_API_WEAK int | evas_canvas_smart_objects_calculate_count_get (const Eo *obj)
| This gets the internal counter that counts the number of smart calculations.
EVAS_API EVAS_API_WEAK Eina_Bool | evas_canvas_focus_state_get (const Eo *obj)
| Get the focus state for the default seat.
EVAS_API EVAS_API_WEAK Eina_Bool | evas_canvas_seat_focus_state_get (const Eo *obj, Evas_Device *seat)
| Get the focus state by a given seat.
EVAS_API EVAS_API_WEAK Eina_Bool | evas_canvas_changed_get (const Eo *obj)
| Get the changed marker for the canvas.
EVAS_API EVAS_API_WEAK void | evas_canvas_pointer_output_xy_by_device_get (const Eo *obj, Evas_Device *dev, int *x, int *y)
| This function returns the current known pointer coordinates.
EVAS_API EVAS_API_WEAK void | evas_canvas_pointer_output_xy_get (const Eo *obj, int *x, int *y)
| This function returns the current known default pointer coordinates.
EVAS_API EVAS_API_WEAK Efl_Canvas_Object * | evas_canvas_object_bottom_get (const Eo *obj)
| Get the lowest (stacked) Evas object on the canvas `e`.
EVAS_API EVAS_API_WEAK unsigned int | evas_canvas_pointer_button_down_mask_by_device_get (const Eo *obj, Evas_Device *dev)
| Returns a bitmask with the mouse buttons currently pressed, set to 1.
EVAS_API EVAS_API_WEAK unsigned int | evas_canvas_pointer_button_down_mask_get (const Eo *obj)
| Returns a bitmask with the default mouse buttons currently pressed, set to 1.
EVAS_API EVAS_API_WEAK Eina_List * | evas_canvas_tree_objects_at_xy_get (Eo *obj, Efl_Canvas_Object *stop, int x, int y)
| Retrieve a list of Evas objects lying over a given position in a canvas.
EVAS_API EVAS_API_WEAK void | evas_canvas_key_lock_on (Eo *obj, const char *keyname)
| Enables or turns on programmatically the lock key with name `keyname` for the default seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_seat_key_lock_on (Eo *obj, const char *keyname, Evas_Device *seat)
| Enables or turns on programmatically the lock key with name `keyname` for a give seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_seat_key_lock_off (Eo *obj, const char *keyname, Evas_Device *seat)
| Disables or turns off programmatically the lock key with name `keyname` for a given seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_key_modifier_add (Eo *obj, const char *keyname)
| Adds the `keyname` key to the current list of modifier keys.
EVAS_API EVAS_API_WEAK void | evas_canvas_key_modifier_off (Eo *obj, const char *keyname)
| Disables or turns off programmatically the modifier key with name `keyname` for the default seat.
EVAS_API EVAS_API_WEAK Eina_Bool | evas_canvas_render_async (Eo *obj)
| Render the given Evas canvas asynchronously.
EVAS_API EVAS_API_WEAK void | evas_canvas_focus_out (Eo *obj)
| Inform the evas that it lost the focus from the default seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_norender (Eo *obj)
| Update the canvas internal objects but not triggering immediate renderization.
EVAS_API EVAS_API_WEAK void | evas_canvas_nochange_pop (Eo *obj)
| Pop the nochange flag down 1.
EVAS_API EVAS_API_WEAK void | evas_canvas_key_lock_off (Eo *obj, const char *keyname)
| Disables or turns off programmatically the lock key with name `keyname` for the default seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_nochange_push (Eo *obj)
| Push the nochange flag up 1.
EVAS_API EVAS_API_WEAK void | evas_canvas_font_cache_flush (Eo *obj)
| Force the given evas and associated engine to flush its font cache.
EVAS_API EVAS_API_WEAK void | evas_canvas_key_modifier_on (Eo *obj, const char *keyname)
| Enables or turns on programmatically the modifier key with name `keyname` for the default seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_seat_key_modifier_on (Eo *obj, const char *keyname, Evas_Device *seat)
| Enables or turns on programmatically the modifier key with name `keyname` for a given seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_seat_key_modifier_off (Eo *obj, const char *keyname, Evas_Device *seat)
| Disables or turns off programmatically the modifier key with name `keyname` for a given seat.
EVAS_API EVAS_API_WEAK Eina_List * | evas_canvas_font_available_list (const Eo *obj)
| List of available font descriptions known or found by this evas.
EVAS_API EVAS_API_WEAK Efl_Canvas_Object * | evas_canvas_object_name_find (const Eo *obj, const char *name)
| Retrieves the object on the given evas with the given name.
EVAS_API EVAS_API_WEAK void | evas_canvas_font_path_append (Eo *obj, const char *path)
| Appends a font path to the list of font paths used by the given evas.
EVAS_API EVAS_API_WEAK void | evas_canvas_font_path_clear (Eo *obj)
| Removes all font paths loaded into memory for the given evas.
EVAS_API EVAS_API_WEAK void | evas_canvas_touch_point_list_nth_xy_get (Eo *obj, unsigned int n, double *x, double *y)
| This function returns the nth touch point's coordinates.
EVAS_API EVAS_API_WEAK void | evas_canvas_key_lock_del (Eo *obj, const char *keyname)
| Removes the `keyname` key from the current list of lock keys on canvas `e`.
EVAS_API EVAS_API_WEAK void | evas_canvas_damage_rectangle_add (Eo *obj, int x, int y, int w, int h)
| Add a damage rectangle.
EVAS_API EVAS_API_WEAK void | evas_canvas_sync (Eo *obj)
| Sync evas canvas.
EVAS_API EVAS_API_WEAK const Eina_List * | evas_canvas_font_path_list (const Eo *obj)
| Retrieves the list of font paths used by the given evas.
EVAS_API EVAS_API_WEAK void | evas_canvas_image_cache_reload (Eo *obj)
| Reload the image cache.
EVAS_API EVAS_API_WEAK int | evas_canvas_coord_world_x_to_screen (const Eo *obj, int x)
| Convert/scale a canvas coordinate into output screen coordinates.
EVAS_API EVAS_API_WEAK Eina_List * | evas_canvas_render_updates (Eo *obj)
| Force immediate renderization of the given Evas canvas.
EVAS_API EVAS_API_WEAK void | evas_canvas_image_cache_flush (Eo *obj)
| Flush the image cache of the canvas.
EVAS_API EVAS_API_WEAK int | evas_canvas_coord_screen_y_to_world (const Eo *obj, int y)
| Convert/scale an output screen coordinate into canvas coordinates.
EVAS_API EVAS_API_WEAK void | evas_canvas_key_modifier_del (Eo *obj, const char *keyname)
| Removes the `keyname` key from the current list of modifier keys on canvas `e`.
EVAS_API EVAS_API_WEAK void | evas_canvas_focus_in (Eo *obj)
| Inform to the evas that it got the focus from the default seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_seat_focus_in (Eo *obj, Evas_Device *seat)
| Inform to the evas that it got the focus from a given seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_seat_focus_out (Eo *obj, Evas_Device *seat)
| Inform to the evas that it lost the focus from a given seat.
EVAS_API EVAS_API_WEAK void | evas_canvas_obscured_rectangle_add (Eo *obj, int x, int y, int w, int h)
| Add an "obscured region" to an Evas canvas.
EVAS_API EVAS_API_WEAK void | evas_canvas_render_dump (Eo *obj)
| Make the canvas discard as much data as possible used by the engine at runtime.
EVAS_API EVAS_API_WEAK void | evas_canvas_render (Eo *obj)
| Force renderization of the given canvas.
EVAS_API EVAS_API_WEAK void | evas_canvas_font_path_prepend (Eo *obj, const char *path)
| Prepends a font path to the list of font paths used by the given evas.
EVAS_API EVAS_API_WEAK void | evas_canvas_obscured_clear (Eo *obj)
| Remove all "obscured regions" from an Evas canvas.
EVAS_API EVAS_API_WEAK int | evas_canvas_coord_screen_x_to_world (const Eo *obj, int x)
| Convert/scale an output screen coordinate into canvas coordinates.
EVAS_API EVAS_API_WEAK void | evas_canvas_key_lock_add (Eo *obj, const char *keyname)
| Adds the `keyname` key to the current list of lock keys.
EVAS_API EVAS_API_WEAK void | evas_canvas_render_idle_flush (Eo *obj)
| Make the canvas discard internally cached data used for rendering.
EVAS_API EVAS_API_WEAK Evas_Device * | evas_canvas_default_device_get (const Eo *obj, Evas_Device_Class type)
| Return the default device of a given type.
EVAS_API EVAS_API_WEAK int | evas_canvas_coord_world_y_to_screen (const Eo *obj, int y)
| Convert/scale a canvas coordinate into output screen coordinates.
EVAS_API void | evas_image_cache_set (Evas_Canvas *obj, int size)
| Set the image cache.
EVAS_API int | evas_image_cache_get (const Evas_Canvas *obj)
| Get the image cache.
EVAS_API void | evas_event_default_flags_set (Evas_Canvas *obj, Evas_Event_Flags flags)
| Set the default set of flags an event begins with.
EVAS_API Evas_Event_Flags | evas_event_default_flags_get (const Evas_Canvas *obj)
| Get the default set of flags an event begins with.
EVAS_API void | evas_font_cache_set (Evas_Canvas *obj, int size)
| Changes the size of font cache of the given evas.
EVAS_API int | evas_font_cache_get (const Evas_Canvas *obj)
| Get the size of font cache of the given evas in bytes.
EVAS_API void | evas_data_attach_set (Evas_Canvas *obj, void *data)
| Attaches a specific pointer to the evas for fetching later.
EVAS_API void * | evas_data_attach_get (const Evas_Canvas *obj)
| Returns the pointer attached by evas_data_attach_set.
EVAS_API Efl_Canvas_Object * | evas_focus_get (const Evas_Canvas *obj)
| Retrieve the object focused by the default seat.
EVAS_API Efl_Canvas_Object * | evas_seat_focus_get (const Evas_Canvas *obj, Evas_Device *seat)
| Return the focused object by a given seat.
EVAS_API Efl_Canvas_Object * | evas_object_top_get (const Evas_Canvas *obj)
| Get the highest (stacked) Evas object on the canvas `e`.
EVAS_API void | evas_pointer_canvas_xy_by_device_get (const Evas_Canvas *obj, Evas_Device *dev, int *x, int *y)
| This function returns the current known default pointer coordinates.
EVAS_API void | evas_pointer_canvas_xy_get (const Evas_Canvas *obj, int *x, int *y)
| This function returns the current known default pointer coordinates.
EVAS_API int | evas_event_down_count_get (const Evas_Canvas *obj)
| Get the number of mouse or multi presses currently active.
EVAS_API int | evas_smart_objects_calculate_count_get (const Evas_Canvas *obj)
| This gets the internal counter that counts the number of smart calculations.
EVAS_API Eina_Bool | evas_focus_state_get (const Evas_Canvas *obj)
| Get the focus state for the default seat.
EVAS_API Eina_Bool | evas_seat_focus_state_get (const Evas_Canvas *obj, Evas_Device *seat)
| Get the focus state by a given seat.
EVAS_API Eina_Bool | evas_changed_get (const Evas_Canvas *obj)
| Get the changed marker for the canvas.
EVAS_API void | evas_pointer_output_xy_by_device_get (const Evas_Canvas *obj, Evas_Device *dev, int *x, int *y)
| This function returns the current known pointer coordinates.
EVAS_API void | evas_pointer_output_xy_get (const Evas_Canvas *obj, int *x, int *y)
| This function returns the current known default pointer coordinates.
EVAS_API Efl_Canvas_Object * | evas_object_bottom_get (const Evas_Canvas *obj)
| Get the lowest (stacked) Evas object on the canvas `e`.
EVAS_API unsigned int | evas_pointer_button_down_mask_by_device_get (const Evas_Canvas *obj, Evas_Device *dev)
| Returns a bitmask with the mouse buttons currently pressed, set to 1.
EVAS_API unsigned int | evas_pointer_button_down_mask_get (const Evas_Canvas *obj)
| Returns a bitmask with the default mouse buttons currently pressed, set to 1.
EVAS_API Eina_List * | evas_tree_objects_at_xy_get (Evas_Canvas *obj, Efl_Canvas_Object *stop, int x, int y)
| Retrieve a list of Evas objects lying over a given position in a canvas.
EVAS_API void | evas_key_lock_on (Evas_Canvas *obj, const char *keyname)
| Enables or turns on programmatically the lock key with name `keyname` for the default seat.
EVAS_API void | evas_seat_key_lock_on (Evas_Canvas *obj, const char *keyname, Evas_Device *seat)
| Enables or turns on programmatically the lock key with name `keyname` for a give seat.
EVAS_API void | evas_seat_key_lock_off (Evas_Canvas *obj, const char *keyname, Evas_Device *seat)
| Disables or turns off programmatically the lock key with name `keyname` for a given seat.
EVAS_API void | evas_key_modifier_add (Evas_Canvas *obj, const char *keyname)
| Adds the `keyname` key to the current list of modifier keys.
EVAS_API void | evas_key_modifier_off (Evas_Canvas *obj, const char *keyname)
| Disables or turns off programmatically the modifier key with name `keyname` for the default seat.
EVAS_API Eina_Bool | evas_render_async (Evas_Canvas *obj)
| Render the given Evas canvas asynchronously.
EVAS_API void | evas_focus_out (Evas_Canvas *obj)
| Inform the evas that it lost the focus from the default seat.
EVAS_API void | evas_norender (Evas_Canvas *obj)
| Update the canvas internal objects but not triggering immediate renderization.
EVAS_API void | evas_norender_with_updates (Eo *eo_e)
| Update the canvas internal objects but not triggering immediate renderization and producing update regions in post-render event.
EVAS_API void | evas_nochange_pop (Evas_Canvas *obj)
| Pop the nochange flag down 1.
EVAS_API void | evas_key_lock_off (Evas_Canvas *obj, const char *keyname)
| Disables or turns off programmatically the lock key with name `keyname` for the default seat.
EVAS_API void | evas_nochange_push (Evas_Canvas *obj)
| Push the nochange flag up 1.
EVAS_API void | evas_font_cache_flush (Evas_Canvas *obj)
| Force the given evas and associated engine to flush its font cache.
EVAS_API void | evas_key_modifier_on (Evas_Canvas *obj, const char *keyname)
| Enables or turns on programmatically the modifier key with name `keyname` for the default seat.
EVAS_API void | evas_seat_key_modifier_on (Evas_Canvas *obj, const char *keyname, Evas_Device *seat)
| Enables or turns on programmatically the modifier key with name `keyname` for a given seat.
EVAS_API void | evas_seat_key_modifier_off (Evas_Canvas *obj, const char *keyname, Evas_Device *seat)
| Disables or turns off programmatically the modifier key with name `keyname` for a given seat.
EVAS_API Eina_List * | evas_font_available_list (const Evas_Canvas *obj)
| List of available font descriptions known or found by this evas.
EVAS_API Efl_Canvas_Object * | evas_object_name_find (const Evas_Canvas *obj, const char *name)
| Retrieves the object on the given evas with the given name.
EVAS_API void | evas_font_path_append (Evas_Canvas *obj, const char *path)
| Appends a font path to the list of font paths used by the given evas.
EVAS_API void | evas_font_path_clear (Evas_Canvas *obj)
| Removes all font paths loaded into memory for the given evas.
EVAS_API void | evas_key_lock_del (Evas_Canvas *obj, const char *keyname)
| Removes the `keyname` key from the current list of lock keys on canvas `e`.
EVAS_API void | evas_damage_rectangle_add (Evas_Canvas *obj, int x, int y, int w, int h)
| Add a damage rectangle.
EVAS_API void | evas_sync (Evas_Canvas *obj)
| Sync evas canvas.
EVAS_API const Eina_List * | evas_font_path_list (const Evas_Canvas *obj)
| Retrieves the list of font paths used by the given evas.
EVAS_API void | evas_image_cache_reload (Evas_Canvas *obj)
| Reload the image cache.
EVAS_API int | evas_coord_world_x_to_screen (const Evas_Canvas *obj, int x)
| Convert/scale a canvas coordinate into output screen coordinates.
EVAS_API Eina_List * | evas_render_updates (Evas_Canvas *obj)
| Force immediate renderization of the given Evas canvas.
EVAS_API void | evas_image_cache_flush (Evas_Canvas *obj)
| Flush the image cache of the canvas.
EVAS_API int | evas_coord_screen_y_to_world (const Evas_Canvas *obj, int y)
| Convert/scale an output screen coordinate into canvas coordinates.
EVAS_API void | evas_key_modifier_del (Evas_Canvas *obj, const char *keyname)
| Removes the `keyname` key from the current list of modifier keys on canvas `e`.
EVAS_API void | evas_focus_in (Evas_Canvas *obj)
| Inform to the evas that it got the focus from the default seat.
EVAS_API void | evas_obscured_rectangle_add (Evas_Canvas *obj, int x, int y, int w, int h)
| Add an "obscured region" to an Evas canvas.
EVAS_API void | evas_render_dump (Evas_Canvas *obj)
| Make the canvas discard as much data as possible used by the engine at runtime.
EVAS_API void | evas_render (Evas_Canvas *obj)
| Force renderization of the given canvas.
EVAS_API void | evas_font_path_prepend (Evas_Canvas *obj, const char *path)
| Prepends a font path to the list of font paths used by the given evas.
EVAS_API void | evas_obscured_clear (Evas_Canvas *obj)
| Remove all "obscured regions" from an Evas canvas.
EVAS_API int | evas_coord_screen_x_to_world (const Evas_Canvas *obj, int x)
| Convert/scale an output screen coordinate into canvas coordinates.
EVAS_API void | evas_key_lock_add (Evas_Canvas *obj, const char *keyname)
| Adds the `keyname` key to the current list of lock keys.
EVAS_API void | evas_render_idle_flush (Evas_Canvas *obj)
| Make the canvas discard internally cached data used for rendering.
EVAS_API Evas_Device * | evas_default_device_get (const Evas_Canvas *obj, Evas_Device_Class type)
| Return the default device of a given type.
EVAS_API int | evas_coord_world_y_to_screen (const Evas_Canvas *obj, int y)
| Convert/scale a canvas coordinate into output screen coordinates.
EVAS_API void | evas_render_updates_free (Eina_List *updates)
| Free the rectangles returned by evas_render_updates().
EVAS_API const Evas_Modifier * | evas_key_modifier_get (const Evas *obj)
| Returns a handle to the list of modifier keys registered in the canvas `e`.
EVAS_API Evas_Modifier_Mask | evas_key_modifier_mask_get (const Evas *evas, const char *keyname)
| Creates a bit mask from the `keyname` modifier key.
EVAS_API const Evas_Lock * | evas_key_lock_get (const Evas *obj)
| Returns a handle to the list of lock keys registered in the canvas `e`.
EVAS_API Eina_Bool | evas_pointer_inside_by_device_get (const Evas *obj, Efl_Input_Device *dev)
| Returns whether the mouse pointer is logically inside the canvas.
EVAS_API Eina_Bool | evas_pointer_inside_get (const Evas *obj)
| Returns whether the default mouse pointer is logically inside the canvas.
EVAS_API Eina_Bool | evas_font_hinting_can_hint (const Evas *e, Evas_Font_Hinting_Flags hinting)
| Checks if the font hinting is supported by the given evas.
EVAS_API Eina_List * | evas_objects_at_xy_get (Eo *eo_e, int x, int y, Eina_Bool include_pass_events_objects, Eina_Bool include_hidden_objects)
| Retrieve a list of objects lying over a given position in a canvas.
EVAS_API Evas_Object * | evas_object_top_at_xy_get (Eo *eo_e, Evas_Coord x, Evas_Coord y, Eina_Bool include_pass_events_objects, Eina_Bool include_hidden_objects)
| Retrieve the object stacked at the top of a given position in a canvas.
EVAS_API Eina_List * | evas_objects_in_rectangle_get (const Eo *obj, int x, int y, int w, int h, Eina_Bool include_pass_events_objects, Eina_Bool include_hidden_objects)
| Get all objects in the given rectangle.
EVAS_API Evas_Object * | evas_object_top_in_rectangle_get (const Eo *obj, int x, int y, int w, int h, Eina_Bool include_pass_events_objects, Eina_Bool include_hidden_objects)
| Retrieve the Evas object stacked at the top of a given rectangular region in a canvas.
EVAS_API void | evas_output_framespace_set (Evas *e, Evas_Coord x, Evas_Coord y, Evas_Coord w, Evas_Coord h)
| Sets the output framespace size of the render engine of the given evas.
EVAS_API void | evas_output_framespace_get (const Evas *e, Evas_Coord *x, Evas_Coord *y, Evas_Coord *w, Evas_Coord *h)
| Get the render engine's output framespace coordinates in canvas units.
EVAS_API void | evas_output_viewport_set (Evas *e, Evas_Coord x, Evas_Coord y, Evas_Coord w, Evas_Coord h)
| Sets the output viewport of the given evas in evas units.
EVAS_API void | evas_output_viewport_get (const Evas *e, Evas_Coord *x, Evas_Coord *y, Evas_Coord *w, Evas_Coord *h)
| Get the render engine's output viewport coordinates in canvas units.
EVAS_API void | evas_output_method_set (Evas *e, int render_method)
| Sets the output engine for the given evas.
EVAS_API int | evas_output_method_get (const Evas *e)
| Retrieves the number of the output engine used for the given evas.
EVAS_API void | evas_output_size_set (Evas *e, int w, int h)
| Sets the output size of the render engine of the given evas.
EVAS_API void | evas_output_size_get (const Evas *e, int *w, int *h)
| Retrieve the output size of the render engine of the given evas.
EVAS_API Evas * | evas_new (void)
| Creates a new empty evas.
EVAS_API void | evas_free (Evas *e)
| Frees the given evas and any objects created on it.
EVAS_API Eina_Bool | evas_engine_info_set (Evas *obj, Evas_Engine_Info *info)
| Applies the engine settings for the given evas from the given `Evas_Engine_Info` structure.
EVAS_API Evas_Engine_Info * | evas_engine_info_get (const Evas *obj)
| Retrieves the current render engine info struct from the given evas.

## Detailed Description

Low level Evas canvas functions.

Sub groups will present more high level ones, though.

Most of these functions deal with low level Evas actions, like:

- create/destroy raw canvases, not bound to any displaying engine
- tell a canvas i got focused (in a windowing context, for example)
- tell a canvas a region should not be calculated anymore in rendering
- tell a canvas to render its contents, immediately

Most users will be using Evas by means of the `Ecore_Evas` wrapper, which deals with all the above mentioned issues automatically for them. Thus, you'll be looking at this section only if you're building low level stuff.

The groups within present you functions that deal with the canvas directly, too, and not yet with its objects. They are the functions you need to use at a minimum to get a working canvas.

Some of the functions in this group are exemplified here.

## Typedef Documentation

## Evas

typedef Eo Evas

An opaque handle to an Evas canvas.

See also
  evas_new()
  evas_free()

Examples
  ctxpopup_example_01.c, ecore_animator_example.c, ecore_evas_basics_example.c, ecore_evas_buffer_example_01.c, ecore_evas_buffer_example_02.c, ecore_evas_object_example.c, ecore_evas_window_sizes_example.c, ecore_imf_example.c, edje-basic.c, edje-box.c, edje-box2.c, edje-color-class.c, edje-drag.c, edje-perspective.c, edje-signals-messages.c, edje-swallow.c, edje-table.c, edje-text.c, efl_thread_4.c, efl_thread_5.c, eina_tiler_01.c, emotion_basic_example.c, emotion_signals_example.c, emotion_test_main.c, entry_example.c, ephysics_logo.c, evas-aspect-hints.c, evas-box.c, evas-buffer-simple.c, evas-events.c, evas-hints.c, evas-images.c, evas-images2.c, evas-map-utils.c, evas-object-manipulation.c, evas-smart-interface.c, evas-smart-object.c, evas-stacking.c, evas-table.c, evas-text.c, glview_example_01.c, map_example_01.c, map_example_02.c, map_example_03.c, menu_example_01.c, slideshow_example.c, test_camera.c, test_camera_track.c, test_collision_detection.c, test_delete.c, test_growing_balls.c, test_rotating_forever.c, test_velocity.c, and web_example_02.c.

## Function Documentation

## evas_canvas_image_cache_set()

EVAS_API EVAS_API_WEAK void evas_canvas_image_cache_set | ( | Eo * | obj,
|  | int | size )

Set the image cache.

This function sets the image cache of canvas in bytes.

Parameters

  [in] | obj | The object.
  [in] | size | The cache size.

Referenced by evas_image_cache_set().

## evas_canvas_image_cache_get()

EVAS_API EVAS_API_WEAK int evas_canvas_image_cache_get | ( | const Eo * | obj | ) |

Get the image cache.

This function returns the image cache size of canvas in bytes.

Parameters

  [in] | obj | The object.

Returns
  The cache size.

Referenced by evas_image_cache_get().

## evas_canvas_event_default_flags_set()

EVAS_API EVAS_API_WEAK void evas_canvas_event_default_flags_set | ( | Eo * | obj,
|  | Evas_Event_Flags | flags )

Set the default set of flags an event begins with.

Events in evas can have an event_flags member. This starts out with an initial value (no flags). This lets you set the default flags that an event begins with to `flags`.

Parameters

  [in] | obj | The object.
  [in] | flags | The default flags to use.

Since
  1.2

Referenced by evas_event_default_flags_set().

## evas_canvas_event_default_flags_get()

EVAS_API EVAS_API_WEAK Evas_Event_Flags evas_canvas_event_default_flags_get | ( | const Eo * | obj | ) |

Get the default set of flags an event begins with.

This gets the default event flags events are produced with when fed in.

Parameters

  [in] | obj | The object.

Returns
  The default flags to use.

Since
  1.2

Referenced by evas_event_default_flags_get().

## evas_canvas_font_cache_set()

EVAS_API EVAS_API_WEAK void evas_canvas_font_cache_set | ( | Eo * | obj,
|  | int | size )

Changes the size of font cache of the given evas.

Parameters

  [in] | obj | The object.
  [in] | size | The size in bytes.

Referenced by evas_font_cache_set().

## evas_canvas_font_cache_get()

EVAS_API EVAS_API_WEAK int evas_canvas_font_cache_get | ( | const Eo * | obj | ) |

Get the size of font cache of the given evas in bytes.

Parameters

  [in] | obj | The object.

Returns
  The size in bytes.

Referenced by evas_font_cache_get().

## evas_canvas_data_attach_set()

EVAS_API EVAS_API_WEAK void evas_canvas_data_attach_set | ( | Eo * | obj,
|  | void * | data )

Attaches a specific pointer to the evas for fetching later.

Parameters

  [in] | obj | The object.
  [in] | data | The attached pointer.

Referenced by evas_data_attach_set().

## evas_canvas_data_attach_get()

EVAS_API EVAS_API_WEAK void * evas_canvas_data_attach_get | ( | const Eo * | obj | ) |

Returns the pointer attached by evas_canvas_data_attach_set.

Parameters

  [in] | obj | The object.

Returns
  The attached pointer.

Referenced by evas_data_attach_get().

## evas_canvas_focus_get()

EVAS_API EVAS_API_WEAK Efl_Canvas_Object * evas_canvas_focus_get | ( | const Eo * | obj | ) |

Retrieve the object focused by the default seat.

Focused objects will be the ones having key events delivered to, which the programmer can act upon by means of evas_object_event_callback_add usage.

Note
  Most users wouldn't be dealing directly with Evas' focused objects. Instead, they would be using a higher level library for that (like a toolkit, as Elementary) to handle focus and who's receiving input for them.

This call returns the object that currently has focus on the canvas `e` or `null`, if none.

See also evas_object_focus_set, evas_object_focus_get, evas_object_key_grab, evas_object_key_ungrab, evas_canvas_seat_focus_get

Parameters

  [in] | obj | The object.

Returns
  The object that has focus or `null` if there is not one.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_focus_get().

## evas_canvas_seat_focus_get()

EVAS_API EVAS_API_WEAK Efl_Canvas_Object * evas_canvas_seat_focus_get | ( | const Eo * | obj,
|  | Evas_Device * | seat )

Return the focused object by a given seat.

Parameters

  [in] | obj | The object.
  [in] | seat | The seat to fetch the focused object or `null` for the default seat.

Returns
  The object that has the focus or `null` if the seat has no focused object.

Since
  1.19

Referenced by evas_seat_focus_get().

## evas_canvas_object_top_get()

EVAS_API EVAS_API_WEAK Efl_Canvas_Object * evas_canvas_object_top_get | ( | const Eo * | obj | ) |

Get the highest (stacked) Evas object on the canvas `e`.

This function will take all populated layers in the canvas into account, getting the highest object for the highest layer, naturally.

Warning
  This function will skip objects parented by smart objects, acting only on the ones at the "top level", with regard to object parenting.

See also evas_object_layer_get, evas_object_layer_set, evas_object_below_get, evas_object_above_get.

Parameters

  [in] | obj | The object.

Returns
  A pointer to the highest object on it (if any) or `null` otherwise.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_object_top_get().

## evas_canvas_pointer_canvas_xy_by_device_get()

EVAS_API EVAS_API_WEAK void evas_canvas_pointer_canvas_xy_by_device_get | ( | const Eo * | obj,
|  | Evas_Device * | dev,
|  | int * | x,
|  | int * | y )

This function returns the current known default pointer coordinates.

Parameters

  [in] | obj | The object.
  [in] | dev | The pointer device.
  [out] | x | The pointer to a Evas_Coord to be filled in.
  [out] | y | The pointer to a Evas_Coord to be filled in.

Since
  1.19

Referenced by evas_pointer_canvas_xy_by_device_get().

## evas_canvas_pointer_canvas_xy_get()

EVAS_API EVAS_API_WEAK void evas_canvas_pointer_canvas_xy_get | ( | const Eo * | obj,
|  | int * | x,
|  | int * | y )

This function returns the current known default pointer coordinates.

This function returns the current known canvas unit coordinates of the mouse pointer and sets the contents of the Evas_Coords pointed to by `x` and `y` to contain these coordinates. If `e` is not a valid canvas the results of this function are undefined.

Parameters

  [in] | obj | The object.
  [out] | x | The pointer to a Evas_Coord to be filled in.
  [out] | y | The pointer to a Evas_Coord to be filled in.

Referenced by evas_pointer_canvas_xy_get().

## evas_canvas_event_down_count_get()

EVAS_API EVAS_API_WEAK int evas_canvas_event_down_count_get | ( | const Eo * | obj | ) |

Get the number of mouse or multi presses currently active.

Parameters

  [in] | obj | The object.

Returns
  Mouse or multi presses currently active

Since
  1.2

Referenced by evas_event_down_count_get().

## evas_canvas_smart_objects_calculate_count_get()

EVAS_API EVAS_API_WEAK int evas_canvas_smart_objects_calculate_count_get | ( | const Eo * | obj | ) |

This gets the internal counter that counts the number of smart calculations.

Whenever evas performs smart object calculations on the whole canvas it increments a counter by 1. This function returns the value of the smart object calculate counter. It starts with a value of 0 and will increase (and eventually wrap around to negative values and so on) by 1 every time objects are calculated. You can use this counter to ensure you don't re-do calculations withint the same calculation generation/run if the calculations maybe cause self-feeding effects.

Parameters

  [in] | obj | The object.

Returns
  Number of smart calculations

Since
  1.1

Referenced by evas_smart_objects_calculate_count_get().

## evas_canvas_focus_state_get()

EVAS_API EVAS_API_WEAK Eina_Bool evas_canvas_focus_state_get | ( | const Eo * | obj | ) |

Get the focus state for the default seat.

Parameters

  [in] | obj | The object.

Returns
  `true` if focused, `false` otherwise

Referenced by evas_focus_state_get().

## evas_canvas_seat_focus_state_get()

EVAS_API EVAS_API_WEAK Eina_Bool evas_canvas_seat_focus_state_get | ( | const Eo * | obj,
|  | Evas_Device * | seat )

Get the focus state by a given seat.

Parameters

  [in] | obj | The object.
  [in] | seat | The seat to check the focus state. Use `null` for the default seat.

Returns
  `true` if the seat has the canvas focus, `false` otherwise.

Referenced by evas_seat_focus_state_get().

## evas_canvas_changed_get()

EVAS_API EVAS_API_WEAK Eina_Bool evas_canvas_changed_get | ( | const Eo * | obj | ) |

Get the changed marker for the canvas.

Parameters

  [in] | obj | The object.

Returns
  `true` if changed, `false` otherwise

Since
  1.11

Referenced by evas_changed_get().

## evas_canvas_pointer_output_xy_by_device_get()

EVAS_API EVAS_API_WEAK void evas_canvas_pointer_output_xy_by_device_get | ( | const Eo * | obj,
|  | Evas_Device * | dev,
|  | int * | x,
|  | int * | y )

This function returns the current known pointer coordinates.

Parameters

  [in] | obj | The object.
  [in] | dev | The mouse device.
  [out] | x | The pointer to an integer to be filled in.
  [out] | y | The pointer to an integer to be filled in.

Since
  1.19

Referenced by evas_pointer_output_xy_by_device_get().

## evas_canvas_pointer_output_xy_get()

EVAS_API EVAS_API_WEAK void evas_canvas_pointer_output_xy_get | ( | const Eo * | obj,
|  | int * | x,
|  | int * | y )

This function returns the current known default pointer coordinates.

This function returns the current known screen/output coordinates of the mouse pointer and sets the contents of the integers pointed to by `x` and `y` to contain these coordinates. If `e` is not a valid canvas the results of this function are undefined.

Parameters

  [in] | obj | The object.
  [out] | x | The pointer to an integer to be filled in.
  [out] | y | The pointer to an integer to be filled in.

Referenced by evas_pointer_output_xy_get().

## evas_canvas_object_bottom_get()

EVAS_API EVAS_API_WEAK Efl_Canvas_Object * evas_canvas_object_bottom_get | ( | const Eo * | obj | ) |

Get the lowest (stacked) Evas object on the canvas `e`.

This function will take all populated layers in the canvas into account, getting the lowest object for the lowest layer, naturally.

Warning
  This function will skip objects parented by smart objects, acting only on the ones at the "top level", with regard to object parenting.

See also evas_object_layer_get, evas_object_layer_set, evas_object_below_get.

Parameters

  [in] | obj | The object.

Returns
  A pointer to the lowest object on it, if any, or `null` otherwise.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_object_bottom_get().

## evas_canvas_pointer_button_down_mask_by_device_get()

EVAS_API EVAS_API_WEAK unsigned int evas_canvas_pointer_button_down_mask_by_device_get | ( | const Eo * | obj,
|  | Evas_Device * | dev )

Returns a bitmask with the mouse buttons currently pressed, set to 1.

Parameters

  [in] | obj | The object.
  [in] | dev | The mouse device.

Returns
  A bitmask of the currently depressed buttons on the canvas.

Referenced by evas_pointer_button_down_mask_by_device_get().

## evas_canvas_pointer_button_down_mask_get()

EVAS_API EVAS_API_WEAK unsigned int evas_canvas_pointer_button_down_mask_get | ( | const Eo * | obj | ) |

Returns a bitmask with the default mouse buttons currently pressed, set to 1.

Calling this function will return a 32-bit integer with the appropriate bits set to 1, which correspond to a mouse button being depressed. This limits Evas to a mouse devices with a maximum of 32 buttons, but that is generally in excess of any host system's pointing device abilities.

A canvas by default begins with no mouse buttons being pressed and only pointer move events can alter that.

The least significant bit corresponds to the first mouse button (button 1) and the most significant bit corresponds to the last mouse button (button 32).

If `e` is not a valid canvas, the return value is undefined.

Parameters

  [in] | obj | The object.

Returns
  A bitmask of the currently depressed buttons on the canvas.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_pointer_button_down_mask_get().

## evas_canvas_tree_objects_at_xy_get()

EVAS_API EVAS_API_WEAK Eina_List * evas_canvas_tree_objects_at_xy_get | ( | Eo * | obj,
|  | Efl_Canvas_Object * | stop,
|  | int | x,
|  | int | y )

Retrieve a list of Evas objects lying over a given position in a canvas.

This function will traverse all the layers of the given canvas, from top to bottom, querying for objects with areas covering the given position. It will enter the smart objects. It will not append to the list pass events as hidden objects. Call eina_list_free on the returned list after usage.

Parameters

  [in] | obj | The object.
  [in] | stop | An Evas Object where to stop searching.
  [in] | x | The horizontal coordinate of the position.
  [in] | y | The vertical coordinate of the position.

Returns
  List of objects

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_tree_objects_at_xy_get().

## evas_canvas_key_lock_on()

EVAS_API EVAS_API_WEAK void evas_canvas_key_lock_on | ( | Eo * | obj,
|  | const char * | keyname )

Enables or turns on programmatically the lock key with name `keyname` for the default seat.

The effect will be as if the key was put on its active state after this call.

See also evas_canvas_key_lock_add, evas_canvas_key_lock_del, evas_canvas_key_lock_del, evas_canvas_key_lock_off, evas_canvas_seat_key_lock_on, evas_canvas_seat_key_lock_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.

Referenced by evas_key_lock_on().

## evas_canvas_seat_key_lock_on()

EVAS_API EVAS_API_WEAK void evas_canvas_seat_key_lock_on | ( | Eo * | obj,
|  | const char * | keyname,
|  | Evas_Device * | seat )

Enables or turns on programmatically the lock key with name `keyname` for a give seat.

The effect will be as if the key was put on its active state after this call.

See also evas_canvas_key_lock_add, evas_canvas_key_lock_del, evas_canvas_key_lock_del, evas_canvas_key_lock_off, evas_canvas_key_lock_on, evas_canvas_seat_key_lock_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.
  [in] | seat | The seat to enable the keylock. A `null` seat repesents the default seat.

Since
  1.19

Referenced by evas_seat_key_lock_on().

## evas_canvas_seat_key_lock_off()

EVAS_API EVAS_API_WEAK void evas_canvas_seat_key_lock_off | ( | Eo * | obj,
|  | const char * | keyname,
|  | Evas_Device * | seat )

Disables or turns off programmatically the lock key with name `keyname` for a given seat.

The effect will be as if the key was put on its inactive state after this call.

See also evas_canvas_key_lock_on, evas_canvas_seat_key_lock_on, evas_canvas_key_lock_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.
  [in] | seat | The seat to disable the keylock. A `null` seat repesents the default seat.

Since
  1.19

Referenced by evas_seat_key_lock_off().

## evas_canvas_key_modifier_add()

EVAS_API EVAS_API_WEAK void evas_canvas_key_modifier_add | ( | Eo * | obj,
|  | const char * | keyname )

Adds the `keyname` key to the current list of modifier keys.

Modifiers are keys like shift, alt and ctrl, i.e. keys which are meant to be pressed together with others, altering the behavior of the second keys pressed. Evas is so that these keys can be user defined.

This call allows custom modifiers to be added to the Evas system at run time. It is then possible to set and unset modifier keys programmatically for other parts of the program to check and act on. Programmers using Evas would check for modifier keys on key event callbacks using evas_key_modifier_is_set.

Note
  If the programmer instantiates the canvas by means of the ecore_evas_new family of helper functions, Ecore will take care of registering on it all standard modifiers: "Shift", "Control", "Alt", "Meta", "Hyper", "Super".

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the modifier key to add to the list of Evas modifiers.

Referenced by evas_key_modifier_add().

## evas_canvas_key_modifier_off()

EVAS_API EVAS_API_WEAK void evas_canvas_key_modifier_off | ( | Eo * | obj,
|  | const char * | keyname )

Disables or turns off programmatically the modifier key with name `keyname` for the default seat.

See also evas_canvas_key_modifier_add, evas_key_modifier_get, evas_canvas_key_modifier_on, evas_canvas_seat_key_modifier_off, evas_canvas_seat_key_modifier_off, evas_key_modifier_is_set, evas_seat_key_modifier_is_set.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the modifier to disable.

Referenced by evas_key_modifier_off().

## evas_canvas_render_async()

EVAS_API EVAS_API_WEAK Eina_Bool evas_canvas_render_async | ( | Eo * | obj | ) |

Render the given Evas canvas asynchronously.

This function only returns `true` when a frame will be rendered. If the previous frame is still rendering, `false` will be returned so the users know not to wait for the updates callback and just return to their main loop.

If a `func` callback is given, a list of updated areas will be generated and the function will be called from the main thread after the rendered frame is flushed to the screen. The resulting list should be freed with evas_render_updates_free.

The list is given in the `event_info` parameter of the callback function.

Parameters

  [in] | obj | The object.

Returns
  `true` if the canvas will render, `false` otherwise.

Since
  1.8

Referenced by evas_render_async().

## evas_canvas_norender()

EVAS_API EVAS_API_WEAK void evas_canvas_norender | ( | Eo * | obj | ) |

Update the canvas internal objects but not triggering immediate renderization.

This function updates the canvas internal objects not triggering renderization. To force renderization function evas_canvas_render should be used.

Parameters

  [in] | obj | The object.

Referenced by evas_norender().

## evas_canvas_nochange_pop()

EVAS_API EVAS_API_WEAK void evas_canvas_nochange_pop | ( | Eo * | obj | ) |

Pop the nochange flag down 1.

This tells evas, that while the nochange flag is greater than 0, do not mark objects as "changed" when making changes.

Warning
  Do not use this function unless you know what Evas exactly works with "changed" state.

Parameters

  [in] | obj | The object.

Referenced by evas_nochange_pop().

## evas_canvas_key_lock_off()

EVAS_API EVAS_API_WEAK void evas_canvas_key_lock_off | ( | Eo * | obj,
|  | const char * | keyname )

Disables or turns off programmatically the lock key with name `keyname` for the default seat.

The effect will be as if the key was put on its inactive state after this call.

See also evas_canvas_key_lock_on, evas_canvas_seat_key_lock_on, evas_canvas_seat_key_lock_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to disable.

Referenced by evas_key_lock_off().

## evas_canvas_nochange_push()

EVAS_API EVAS_API_WEAK void evas_canvas_nochange_push | ( | Eo * | obj | ) |

Push the nochange flag up 1.

This tells evas, that while the nochange flag is greater than 0, do not mark objects as "changed" when making changes.

Warning
  Do not use this function unless you know what Evas exactly works with "changed" state.

Parameters

  [in] | obj | The object.

Referenced by evas_nochange_push().

## evas_canvas_key_modifier_on()

EVAS_API EVAS_API_WEAK void evas_canvas_key_modifier_on | ( | Eo * | obj,
|  | const char * | keyname )

Enables or turns on programmatically the modifier key with name `keyname` for the default seat.

The effect will be as if the key was pressed for the whole time between this call and a matching evas_key_modifier_off().

See also evas_canvas_key_modifier_off, evas_canvas_seat_key_modifier_on, evas_canvas_seat_key_modifier_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the modifier to enable.

Referenced by evas_key_modifier_on().

## evas_canvas_seat_key_modifier_on()

EVAS_API EVAS_API_WEAK void evas_canvas_seat_key_modifier_on | ( | Eo * | obj,
|  | const char * | keyname,
|  | Evas_Device * | seat )

Enables or turns on programmatically the modifier key with name `keyname` for a given seat.

The effect will be as if the key was pressed for the whole time between this call and a matching evas_canvas_seat_key_modifier_off.

See also evas_canvas_key_modifier_off, evas_canvas_seat_key_modifier_on, evas_canvas_seat_key_modifier_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.
  [in] | seat | The seat to enable the modifier. A `null` seat repesents the default seat.

Since
  1.19

Referenced by evas_seat_key_modifier_on().

## evas_canvas_seat_key_modifier_off()

EVAS_API EVAS_API_WEAK void evas_canvas_seat_key_modifier_off | ( | Eo * | obj,
|  | const char * | keyname,
|  | Evas_Device * | seat )

Disables or turns off programmatically the modifier key with name `keyname` for a given seat.

See also evas_canvas_key_modifier_add, evas_key_modifier_get, evas_canvas_key_modifier_on, evas_canvas_seat_key_modifier_off, evas_canvas_seat_key_modifier_off, evas_key_modifier_is_set, evas_seat_key_modifier_is_set.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.
  [in] | seat | The seat to disable the modifier. A `null` seat repesents the default seat.

Since
  1.19

Referenced by evas_seat_key_modifier_off().

## evas_canvas_font_available_list()

EVAS_API EVAS_API_WEAK Eina_List * evas_canvas_font_available_list | ( | const Eo * | obj | ) |

List of available font descriptions known or found by this evas.

The list depends on Evas compile time configuration, such as fontconfig support, and the paths provided at runtime as explained in Font Path Functions.

Parameters

  [in] | obj | The object.

Returns
  A newly allocated list of strings. Do not change the strings. Be sure to call evas_font_available_list_free after you're done.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_font_available_list().

## evas_canvas_object_name_find()

EVAS_API EVAS_API_WEAK Efl_Canvas_Object * evas_canvas_object_name_find | ( | const Eo * | obj,
|  | const char * | name )

Retrieves the object on the given evas with the given name.

This looks for the evas object given a name by evas_object_name_set. If the name is not unique canvas-wide, then which one of the many objects with that name is returned is undefined, so only use this if you can ensure the object name is unique.

Parameters

  [in] | obj | The object.
  [in] | name | The given name.

Returns
  If successful, the Evas object with the given name. Otherwise, `null`.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_object_name_find().

## evas_canvas_font_path_append()

EVAS_API EVAS_API_WEAK void evas_canvas_font_path_append | ( | Eo * | obj,
|  | const char * | path )

Appends a font path to the list of font paths used by the given evas.

Parameters

  [in] | obj | The object.
  [in] | path | The new font path.

Referenced by evas_font_path_append().

## evas_canvas_touch_point_list_nth_xy_get()

EVAS_API EVAS_API_WEAK void evas_canvas_touch_point_list_nth_xy_get | ( | Eo * | obj,
|  | unsigned int | n,
|  | double * | x,
|  | double * | y )

This function returns the nth touch point's coordinates.

Touch point's coordinates is updated whenever moving that point on the canvas.

Parameters

  [in] | obj | The object.
  [in] | n | The number of the touched point (0 being the first).
  [out] | x | Last known X position in window coordinates
  [out] | y | Last known Y position in window coordinates

## evas_canvas_key_lock_del()

EVAS_API EVAS_API_WEAK void evas_canvas_key_lock_del | ( | Eo * | obj,
|  | const char * | keyname )

Removes the `keyname` key from the current list of lock keys on canvas `e`.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the key to remove from the locks list.

Referenced by evas_key_lock_del().

## evas_canvas_damage_rectangle_add()

EVAS_API EVAS_API_WEAK void evas_canvas_damage_rectangle_add | ( | Eo * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h )

Add a damage rectangle.

This is the function by which one tells evas that a part of the canvas has to be repainted.

Note
  All newly created Evas rectangles get the default color values of 255 255 255 255 (opaque white).

Parameters

  [in] | obj | The object.
  [in] | x | The rectangle's left position.
  [in] | y | The rectangle's top position.
  [in] | w | The rectangle's width.
  [in] | h | The rectangle's height.

Referenced by evas_damage_rectangle_add().

## evas_canvas_font_path_list()

EVAS_API EVAS_API_WEAK const Eina_List * evas_canvas_font_path_list | ( | const Eo * | obj | ) |

Retrieves the list of font paths used by the given evas.

Parameters

  [in] | obj | The object.

Returns
  The list of font paths used.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_font_path_list().

## evas_canvas_image_cache_reload()

EVAS_API EVAS_API_WEAK void evas_canvas_image_cache_reload | ( | Eo * | obj | ) |

Reload the image cache.

This function reloads the image cache of canvas.

Parameters

  [in] | obj | The object.

Referenced by evas_image_cache_reload().

## evas_canvas_coord_world_x_to_screen()

EVAS_API EVAS_API_WEAK int evas_canvas_coord_world_x_to_screen | ( | const Eo * | obj,
|  | int | x )

Convert/scale a canvas coordinate into output screen coordinates.

This function takes in a horizontal coordinate as the `x` parameter and converts it into output units, accounting for output size, viewport size and location, returning it as the function return value. If `e` is invalid, the results are undefined.

Parameters

  [in] | obj | The object.
  [in] | x | The canvas X coordinate.

Returns
  The output/screen coordinate translated to output coordinates.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_coord_world_x_to_screen().

## evas_canvas_render_updates()

EVAS_API EVAS_API_WEAK Eina_List * evas_canvas_render_updates | ( | Eo * | obj | ) |

Force immediate renderization of the given Evas canvas.

This function forces an immediate renderization update of the given canvas `e`.

Note
  This is a very low level function, which most of Evas' users wouldn't care about. You might use it, for instance, to grab an Evas' canvas update regions and paint them back, using the canvas' pixmap, on a displaying system working below Evas.
  Evas is a stateful canvas. If no operations changing its state took place since the last rendering action, you won't see any changes and this call will be a no-op.

Parameters

  [in] | obj | The object.

Returns
  A newly allocated list of updated rectangles of the canvas (Eina_Rect structs). Free this list with evas_render_updates_free.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_render_updates().

## evas_canvas_image_cache_flush()

EVAS_API EVAS_API_WEAK void evas_canvas_image_cache_flush | ( | Eo * | obj | ) |

Flush the image cache of the canvas.

This function flushes image cache of canvas.

Parameters

  [in] | obj | The object.

Referenced by evas_image_cache_flush().

## evas_canvas_coord_screen_y_to_world()

EVAS_API EVAS_API_WEAK int evas_canvas_coord_screen_y_to_world | ( | const Eo * | obj,
|  | int | y )

Convert/scale an output screen coordinate into canvas coordinates.

This function takes in a vertical coordinate as the `y` parameter and converts it into canvas units, accounting for output size, viewport size and location, returning it as the function return value. If `e` is invalid, the results are undefined.

Parameters

  [in] | obj | The object.
  [in] | y | The screen/output y coordinate.

Returns
  The screen coordinate translated to canvas unit coordinates.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_coord_screen_y_to_world().

## evas_canvas_key_modifier_del()

EVAS_API EVAS_API_WEAK void evas_canvas_key_modifier_del | ( | Eo * | obj,
|  | const char * | keyname )

Removes the `keyname` key from the current list of modifier keys on canvas `e`.

See also evas_canvas_key_modifier_add.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the key to remove from the modifiers list.

Referenced by evas_key_modifier_del().

## evas_canvas_seat_focus_in()

EVAS_API EVAS_API_WEAK void evas_canvas_seat_focus_in | ( | Eo * | obj,
|  | Evas_Device * | seat )

Inform to the evas that it got the focus from a given seat.

Parameters

  [in] | obj | The object.
  [in] | seat | The seat or `null` for the default seat.

Since
  1.19

## evas_canvas_seat_focus_out()

EVAS_API EVAS_API_WEAK void evas_canvas_seat_focus_out | ( | Eo * | obj,
|  | Evas_Device * | seat )

Inform to the evas that it lost the focus from a given seat.

Parameters

  [in] | obj | The object.
  [in] | seat | The seat or `null` for the default seat.

Since
  1.19

## evas_canvas_obscured_rectangle_add()

EVAS_API EVAS_API_WEAK void evas_canvas_obscured_rectangle_add | ( | Eo * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h )

Add an "obscured region" to an Evas canvas.

This is the function by which one tells an Evas canvas that a part of it must not be repainted. The region must be rectangular and its coordinates inside the canvas viewport are passed in the call. After this call, the region specified won't participate in any form in Evas' calculations and actions during its rendering updates, having its displaying content frozen as it was just after this function took place.

We call it "obscured region" because the most common use case for this rendering (partial) freeze is something else (most probably other canvas) being on top of the specified rectangular region, thus shading it completely from the user's final scene in a display. To avoid unnecessary processing, one should indicate to the obscured canvas not to bother about the non-important area.

The majority of users won't have to worry about this function, as they'll be using just one canvas in their applications, with nothing inset or on top of it in any form.

To make this region one that has to be repainted again, call the function evas_obscured_clear.

Note
  This is a very low level function, which most of Evas' users wouldn't care about.
  This function does not flag the canvas as having its state changed. If you want to re-render it afterwards expecting new contents, you have to add "damage" regions yourself (see evas_damage_rectangle_add).

Parameters

  [in] | obj | The object.
  [in] | x | The rectangle's top left corner's horizontal coordinate.
  [in] | y | The rectangle's top left corner's vertical coordinate.
  [in] | w | The rectangle's width.
  [in] | h | The rectangle's height.

Referenced by evas_obscured_rectangle_add().

## evas_canvas_render_dump()

EVAS_API EVAS_API_WEAK void evas_canvas_render_dump | ( | Eo * | obj | ) |

Make the canvas discard as much data as possible used by the engine at runtime.

This function will unload images, delete textures and much more where possible. You may also want to call evas_canvas_render_idle_flush immediately prior to this to perhaps discard a little more, though this function should implicitly delete most of what evas_canvas_render_idle_flush might discard too.

Parameters

  [in] | obj | The object.

Referenced by evas_render_dump().

## evas_canvas_font_path_prepend()

EVAS_API EVAS_API_WEAK void evas_canvas_font_path_prepend | ( | Eo * | obj,
|  | const char * | path )

Prepends a font path to the list of font paths used by the given evas.

Parameters

  [in] | obj | The object.
  [in] | path | The new font path.

Referenced by evas_font_path_prepend().

## evas_canvas_obscured_clear()

EVAS_API EVAS_API_WEAK void evas_canvas_obscured_clear | ( | Eo * | obj | ) |

Remove all "obscured regions" from an Evas canvas.

This function removes all the rectangles from the obscured regions list of the canvas `e`. It takes obscured areas added with evas_canvas_obscured_rectangle_add and make them again a regions that have to be repainted on rendering updates.

Note
  This is a very low level function, which most of Evas' users wouldn't care about.
  This function does not flag the canvas as having its state changed. If you want to re-render it afterwards expecting new contents, you have to add "damage" regions yourself (see evas_canvas_damage_rectangle_add).

Parameters

  [in] | obj | The object.

Referenced by evas_obscured_clear().

## evas_canvas_coord_screen_x_to_world()

EVAS_API EVAS_API_WEAK int evas_canvas_coord_screen_x_to_world | ( | const Eo * | obj,
|  | int | x )

Convert/scale an output screen coordinate into canvas coordinates.

This function takes in a horizontal coordinate as the `x` parameter and converts it into canvas units, accounting for output size, viewport size and location, returning it as the function return value. If `e` is invalid, the results are undefined.

Parameters

  [in] | obj | The object.
  [in] | x | The screen/output x coordinate.

Returns
  The screen coordinate translated to canvas unit coordinates.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_coord_screen_x_to_world().

## evas_canvas_key_lock_add()

EVAS_API EVAS_API_WEAK void evas_canvas_key_lock_add | ( | Eo * | obj,
|  | const char * | keyname )

Adds the `keyname` key to the current list of lock keys.

Locks are keys like caps lock, num lock or scroll lock, i.e., keys which are meant to be pressed once – toggling a binary state which is bound to it – and thus altering the behavior of all subsequently pressed keys somehow, depending on its state. Evas is so that these keys can be defined by the user.

This allows custom locks to be added to the evas system at run time. It is then possible to set and unset lock keys programmatically for other parts of the program to check and act on. Programmers using Evas would check for lock keys on key event callbacks using evas_key_lock_is_set.

Note
  If the programmer instantiates the canvas by means of the ecore_evas_new() family of helper functions, Ecore will take care of registering on it all standard lock keys: "Caps_Lock", "Num_Lock", "Scroll_Lock".

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the key to add to the locks list.

Referenced by evas_key_lock_add().

## evas_canvas_render_idle_flush()

EVAS_API EVAS_API_WEAK void evas_canvas_render_idle_flush | ( | Eo * | obj | ) |

Make the canvas discard internally cached data used for rendering.

This function flushes the arrays of delete, active and render objects. Other things it may also discard are: shared memory segments, temporary scratch buffers, cached data to avoid re-compute of that data etc.

Parameters

  [in] | obj | The object.

Referenced by evas_render_idle_flush().

## evas_canvas_default_device_get()

EVAS_API EVAS_API_WEAK Evas_Device * evas_canvas_default_device_get | ( | const Eo * | obj,
|  | Evas_Device_Class | type )

Return the default device of a given type.

Note
  Currently EFL only creates a seat, mouse and keyboard.

Parameters

  [in] | obj | The object.
  [in] | type | The class of the default device to fetch.

Returns
  The default device or `null` on error.

Since
  1.19

Referenced by evas_default_device_get().

## evas_canvas_coord_world_y_to_screen()

EVAS_API EVAS_API_WEAK int evas_canvas_coord_world_y_to_screen | ( | const Eo * | obj,
|  | int | y )

Convert/scale a canvas coordinate into output screen coordinates.

This function takes in a vertical coordinate as the `x` parameter and converts it into output units, accounting for output size, viewport size and location, returning it as the function return value. If `e` is invalid, the results are undefined.

Parameters

  [in] | obj | The object.
  [in] | y | The canvas y coordinate.

Returns
  The output/screen coordinate translated to output coordinates.

References EINA_WARN_UNUSED_RESULT.

Referenced by evas_coord_world_y_to_screen().

## evas_image_cache_set()

EVAS_API void evas_image_cache_set | ( | Evas_Canvas * | obj,
|  | int | size )

Set the image cache.

This function sets the image cache of canvas in bytes.

Parameters

  [in] | obj | The object.
  [in] | size | The cache size.

References evas_canvas_image_cache_set().

Referenced by ethumb_dup(), and ethumb_new().

## evas_image_cache_get()

EVAS_API int evas_image_cache_get | ( | const Evas_Canvas * | obj | ) |

Get the image cache.

This function returns the image cache size of canvas in bytes.

Parameters

  [in] | obj | The object.

Returns
  The cache size.

References evas_canvas_image_cache_get().

## evas_event_default_flags_set()

EVAS_API void evas_event_default_flags_set | ( | Evas_Canvas * | obj,
|  | Evas_Event_Flags | flags )

Set the default set of flags an event begins with.

Events in evas can have an event_flags member. This starts out with an initial value (no flags). This lets you set the default flags that an event begins with to `flags`.

Parameters

  [in] | obj | The object.
  [in] | flags | The default flags to use.

Since
  1.2

References evas_canvas_event_default_flags_set().

## evas_event_default_flags_get()

EVAS_API Evas_Event_Flags evas_event_default_flags_get | ( | const Evas_Canvas * | obj | ) |

Get the default set of flags an event begins with.

This gets the default event flags events are produced with when fed in.

Parameters

  [in] | obj | The object.

Returns
  The default flags to use.

Since
  1.2

References evas_canvas_event_default_flags_get().

## evas_font_cache_set()

EVAS_API void evas_font_cache_set | ( | Evas_Canvas * | obj,
|  | int | size )

Changes the size of font cache of the given evas.

Parameters

  [in] | obj | The object.
  [in] | size | The size in bytes.

References evas_canvas_font_cache_set().

Referenced by ethumb_dup(), and ethumb_new().

## evas_font_cache_get()

EVAS_API int evas_font_cache_get | ( | const Evas_Canvas * | obj | ) |

Get the size of font cache of the given evas in bytes.

Parameters

  [in] | obj | The object.

Returns
  The size in bytes.

References evas_canvas_font_cache_get().

## evas_data_attach_set()

EVAS_API void evas_data_attach_set | ( | Evas_Canvas * | obj,
|  | void * | data )

Attaches a specific pointer to the evas for fetching later.

Parameters

  [in] | obj | The object.
  [in] | data | The attached pointer.

References evas_canvas_data_attach_set().

Referenced by ecore_evas_object_image_new().

## evas_data_attach_get()

EVAS_API void * evas_data_attach_get | ( | const Evas_Canvas * | obj | ) |

Returns the pointer attached by evas_data_attach_set.

Parameters

  [in] | obj | The object.

Returns
  The attached pointer.

References evas_canvas_data_attach_get().

Referenced by ecore_evas_ecore_evas_get().

## evas_focus_get()

EVAS_API Efl_Canvas_Object * evas_focus_get | ( | const Evas_Canvas * | obj | ) |

Retrieve the object focused by the default seat.

Focused objects will be the ones having key events delivered to, which the programmer can act upon by means of evas_object_event_callback_add usage.

Note
  Most users wouldn't be dealing directly with Evas' focused objects. Instead, they would be using a higher level library for that (like a toolkit, as Elementary) to handle focus and who's receiving input for them.

This call returns the object that currently has focus on the canvas `e` or `null`, if none.

See also evas_object_focus_set, evas_object_focus_get, evas_object_key_grab, evas_object_key_ungrab, evas_seat_focus_get.

Parameters

  [in] | obj | The object.

Returns
  The object that has focus or `null` if there is not one.

References evas_canvas_focus_get().

## evas_seat_focus_get()

EVAS_API Efl_Canvas_Object * evas_seat_focus_get | ( | const Evas_Canvas * | obj,
|  | Evas_Device * | seat )

Return the focused object by a given seat.

Parameters

  [in] | obj | The object.
  [in] | seat | The seat to fetch the focused object or `null` for the default seat.

Returns
  The object that has the focus or `null` if the seat has no focused object.

Since
  1.19

References evas_canvas_seat_focus_get().

## evas_object_top_get()

EVAS_API Efl_Canvas_Object * evas_object_top_get | ( | const Evas_Canvas * | obj | ) |

Get the highest (stacked) Evas object on the canvas `e`.

This function will take all populated layers in the canvas into account, getting the highest object for the highest layer, naturally.

Warning
  This function will skip objects parented by smart objects, acting only on the ones at the "top level", with regard to object parenting.

See also evas_object_layer_get, evas_object_layer_set, evas_object_below_get, evas_object_above_get.

Parameters

  [in] | obj | The object.

Returns
  A pointer to the highest object on it (if any) or `null` otherwise.

References evas_canvas_object_top_get().

## evas_pointer_canvas_xy_by_device_get()

EVAS_API void evas_pointer_canvas_xy_by_device_get | ( | const Evas_Canvas * | obj,
|  | Evas_Device * | dev,
|  | int * | x,
|  | int * | y )

This function returns the current known default pointer coordinates.

Parameters

  [in] | obj | The object.
  [in] | dev | The pointer device.
  [out] | x | The pointer to a Evas_Coord to be filled in.
  [out] | y | The pointer to a Evas_Coord to be filled in.

Since
  1.19

References evas_canvas_pointer_canvas_xy_by_device_get().

## evas_pointer_canvas_xy_get()

EVAS_API void evas_pointer_canvas_xy_get | ( | const Evas_Canvas * | obj,
|  | int * | x,
|  | int * | y )

This function returns the current known default pointer coordinates.

This function returns the current known canvas unit coordinates of the mouse pointer and sets the contents of the Evas_Coords pointed to by `x` and `y` to contain these coordinates. If `e` is not a valid canvas the results of this function are undefined.

Parameters

  [in] | obj | The object.
  [out] | x | The pointer to a Evas_Coord to be filled in.
  [out] | y | The pointer to a Evas_Coord to be filled in.

References evas_canvas_pointer_canvas_xy_get().

Referenced by elm_drag_start().

## evas_event_down_count_get()

EVAS_API int evas_event_down_count_get | ( | const Evas_Canvas * | obj | ) |

Get the number of mouse or multi presses currently active.

Parameters

  [in] | obj | The object.

Returns
  Mouse or multi presses currently active

Since
  1.2

References evas_canvas_event_down_count_get().

## evas_smart_objects_calculate_count_get()

EVAS_API int evas_smart_objects_calculate_count_get | ( | const Evas_Canvas * | obj | ) |

This gets the internal counter that counts the number of smart calculations.

Whenever evas performs smart object calculations on the whole canvas it increments a counter by 1. This function returns the value of the smart object calculate counter. It starts with a value of 0 and will increase (and eventually wrap around to negative values and so on) by 1 every time objects are calculated. You can use this counter to ensure you don't re-do calculations withint the same calculation generation/run if the calculations maybe cause self-feeding effects.

Parameters

  [in] | obj | The object.

Returns
  Number of smart calculations

Since
  1.1

References evas_canvas_smart_objects_calculate_count_get().

## evas_focus_state_get()

EVAS_API Eina_Bool evas_focus_state_get | ( | const Evas_Canvas * | obj | ) |

Get the focus state for the default seat.

Parameters

  [in] | obj | The object.

Returns
  `true` if focused, `false` otherwise

References evas_canvas_focus_state_get().

## evas_seat_focus_state_get()

EVAS_API Eina_Bool evas_seat_focus_state_get | ( | const Evas_Canvas * | obj,
|  | Evas_Device * | seat )

Get the focus state by a given seat.

Parameters

  [in] | obj | The object.
  [in] | seat | The seat to check the focus state. Use `null` for the default seat.

Returns
  `true` if the seat has the canvas focus, `false` otherwise.

References evas_canvas_seat_focus_state_get().

## evas_changed_get()

EVAS_API Eina_Bool evas_changed_get | ( | const Evas_Canvas * | obj | ) |

Get the changed marker for the canvas.

Parameters

  [in] | obj | The object.

Returns
  `true` if changed, `false` otherwise

Since
  1.11

References evas_canvas_changed_get().

## evas_pointer_output_xy_by_device_get()

EVAS_API void evas_pointer_output_xy_by_device_get | ( | const Evas_Canvas * | obj,
|  | Evas_Device * | dev,
|  | int * | x,
|  | int * | y )

This function returns the current known pointer coordinates.

Parameters

  [in] | obj | The object.
  [in] | dev | The mouse device.
  [out] | x | The pointer to an integer to be filled in.
  [out] | y | The pointer to an integer to be filled in.

Since
  1.19

References evas_canvas_pointer_output_xy_by_device_get().

## evas_pointer_output_xy_get()

EVAS_API void evas_pointer_output_xy_get | ( | const Evas_Canvas * | obj,
|  | int * | x,
|  | int * | y )

This function returns the current known default pointer coordinates.

This function returns the current known screen/output coordinates of the mouse pointer and sets the contents of the integers pointed to by `x` and `y` to contain these coordinates. If `e` is not a valid canvas the results of this function are undefined.

Parameters

  [in] | obj | The object.
  [out] | x | The pointer to an integer to be filled in.
  [out] | y | The pointer to an integer to be filled in.

References evas_canvas_pointer_output_xy_get().

## evas_object_bottom_get()

EVAS_API Efl_Canvas_Object * evas_object_bottom_get | ( | const Evas_Canvas * | obj | ) |

Get the lowest (stacked) Evas object on the canvas `e`.

This function will take all populated layers in the canvas into account, getting the lowest object for the lowest layer, naturally.

Warning
  This function will skip objects parented by smart objects, acting only on the ones at the "top level", with regard to object parenting.

See also evas_object_layer_get, evas_object_layer_set, evas_object_below_get.

Parameters

  [in] | obj | The object.

Returns
  A pointer to the lowest object on it, if any, or `null` otherwise.

References evas_canvas_object_bottom_get().

## evas_pointer_button_down_mask_by_device_get()

EVAS_API unsigned int evas_pointer_button_down_mask_by_device_get | ( | const Evas_Canvas * | obj,
|  | Evas_Device * | dev )

Returns a bitmask with the mouse buttons currently pressed, set to 1.

Parameters

  [in] | obj | The object.
  [in] | dev | The mouse device.

Returns
  A bitmask of the currently depressed buttons on the canvas.

References evas_canvas_pointer_button_down_mask_by_device_get().

## evas_pointer_button_down_mask_get()

EVAS_API unsigned int evas_pointer_button_down_mask_get | ( | const Evas_Canvas * | obj | ) |

Returns a bitmask with the default mouse buttons currently pressed, set to 1.

Calling this function will return a 32-bit integer with the appropriate bits set to 1, which correspond to a mouse button being depressed. This limits Evas to a mouse devices with a maximum of 32 buttons, but that is generally in excess of any host system's pointing device abilities.

A canvas by default begins with no mouse buttons being pressed and only pointer move events can alter that.

The least significant bit corresponds to the first mouse button (button 1) and the most significant bit corresponds to the last mouse button (button 32).

If `e` is not a valid canvas, the return value is undefined.

Parameters

  [in] | obj | The object.

Returns
  A bitmask of the currently depressed buttons on the canvas.

References evas_canvas_pointer_button_down_mask_get().

## evas_tree_objects_at_xy_get()

EVAS_API Eina_List * evas_tree_objects_at_xy_get | ( | Evas_Canvas * | obj,
|  | Efl_Canvas_Object * | stop,
|  | int | x,
|  | int | y )

Retrieve a list of Evas objects lying over a given position in a canvas.

This function will traverse all the layers of the given canvas, from top to bottom, querying for objects with areas covering the given position. It will enter the smart objects. It will not append to the list pass events as hidden objects. Call eina_list_free on the returned list after usage.

Parameters

  [in] | obj | The object.
  [in] | stop | An Evas Object where to stop searching.
  [in] | x | The horizontal coordinate of the position.
  [in] | y | The vertical coordinate of the position.

Returns
  List of objects

References evas_canvas_tree_objects_at_xy_get().

## evas_key_lock_on()

EVAS_API void evas_key_lock_on | ( | Evas_Canvas * | obj,
|  | const char * | keyname )

Enables or turns on programmatically the lock key with name `keyname` for the default seat.

The effect will be as if the key was put on its active state after this call.

See also evas_key_lock_add, evas_key_lock_del, evas_key_lock_del, evas_key_lock_off, evas_seat_key_lock_on, evas_seat_key_lock_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.

References evas_canvas_key_lock_on().

## evas_seat_key_lock_on()

EVAS_API void evas_seat_key_lock_on | ( | Evas_Canvas * | obj,
|  | const char * | keyname,
|  | Evas_Device * | seat )

Enables or turns on programmatically the lock key with name `keyname` for a give seat.

The effect will be as if the key was put on its active state after this call.

See also evas_key_lock_add, evas_key_lock_del, evas_key_lock_del, evas_key_lock_off, evas_key_lock_on, evas_seat_key_lock_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.
  [in] | seat | The seat to enable the keylock. A `null` seat repesents the default seat.

Since
  1.19

References evas_canvas_seat_key_lock_on().

## evas_seat_key_lock_off()

EVAS_API void evas_seat_key_lock_off | ( | Evas_Canvas * | obj,
|  | const char * | keyname,
|  | Evas_Device * | seat )

Disables or turns off programmatically the lock key with name `keyname` for a given seat.

The effect will be as if the key was put on its inactive state after this call.

See also evas_key_lock_on, evas_seat_key_lock_on, evas_key_lock_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.
  [in] | seat | The seat to disable the keylock. A `null` seat repesents the default seat.

Since
  1.19

References evas_canvas_seat_key_lock_off().

## evas_key_modifier_add()

EVAS_API void evas_key_modifier_add | ( | Evas_Canvas * | obj,
|  | const char * | keyname )

Adds the `keyname` key to the current list of modifier keys.

Modifiers are keys like shift, alt and ctrl, i.e. keys which are meant to be pressed together with others, altering the behavior of the second keys pressed. Evas is so that these keys can be user defined.

This call allows custom modifiers to be added to the Evas system at run time. It is then possible to set and unset modifier keys programmatically for other parts of the program to check and act on. Programmers using Evas would check for modifier keys on key event callbacks using evas_key_modifier_is_set.

Note
  If the programmer instantiates the canvas by means of the ecore_evas_new family of helper functions, Ecore will take care of registering on it all standard modifiers: "Shift", "Control", "Alt", "Meta", "Hyper", "Super".

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the modifier key to add to the list of Evas modifiers.

References evas_canvas_key_modifier_add().

Referenced by ecore_evas_buffer_allocfunc_new(), and ecore_evas_object_image_new().

## evas_key_modifier_off()

EVAS_API void evas_key_modifier_off | ( | Evas_Canvas * | obj,
|  | const char * | keyname )

Disables or turns off programmatically the modifier key with name `keyname` for the default seat.

See also evas_key_modifier_add, evas_key_modifier_get, evas_key_modifier_on, evas_seat_key_modifier_off, evas_seat_key_modifier_off, evas_key_modifier_is_set, evas_seat_key_modifier_is_set.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the modifier to disable.

References evas_canvas_key_modifier_off().

## evas_render_async()

EVAS_API Eina_Bool evas_render_async | ( | Evas_Canvas * | obj | ) |

Render the given Evas canvas asynchronously.

This function only returns `true` when a frame will be rendered. If the previous frame is still rendering, `false` will be returned so the users know not to wait for the updates callback and just return to their main loop.

If a `func` callback is given, a list of updated areas will be generated and the function will be called from the main thread after the rendered frame is flushed to the screen. The resulting list should be freed with evas_render_updates_free.

The list is given in the `event_info` parameter of the callback function.

Parameters

  [in] | obj | The object.

Returns
  `true` if the canvas will render, `false` otherwise.

Since
  1.8

References evas_canvas_render_async().

## evas_norender()

EVAS_API void evas_norender | ( | Evas_Canvas * | obj | ) |

Update the canvas internal objects but not triggering immediate renderization.

This function updates the canvas internal objects not triggering renderization. To force renderization function evas_render should be used.

Parameters

  [in] | obj | The object.

References evas_canvas_norender().

## evas_norender_with_updates()

EVAS_API void evas_norender_with_updates | ( | Eo * | eo_e | ) |

Update the canvas internal objects but not triggering immediate renderization and producing update regions in post-render event.

This function updates the canvas internal objects not triggering renderization. To force renderization function evas_render should be used.

Parameters

  [in] | eo_e | The object.

Since
  1.24

References EINA_LIST_FREE, eina_rectangle_free(), and EVAS_CANVAS_CLASS.

## evas_nochange_pop()

EVAS_API void evas_nochange_pop | ( | Evas_Canvas * | obj | ) |

Pop the nochange flag down 1.

This tells evas, that while the nochange flag is greater than 0, do not mark objects as "changed" when making changes.

Warning
  Do not use this function unless you know what Evas exactly works with "changed" state.

Parameters

  [in] | obj | The object.

References evas_canvas_nochange_pop().

## evas_key_lock_off()

EVAS_API void evas_key_lock_off | ( | Evas_Canvas * | obj,
|  | const char * | keyname )

Disables or turns off programmatically the lock key with name `keyname` for the default seat.

The effect will be as if the key was put on its inactive state after this call.

See also evas_key_lock_on, evas_seat_key_lock_on, evas_seat_key_lock_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to disable.

References evas_canvas_key_lock_off().

## evas_nochange_push()

EVAS_API void evas_nochange_push | ( | Evas_Canvas * | obj | ) |

Push the nochange flag up 1.

This tells evas, that while the nochange flag is greater than 0, do not mark objects as "changed" when making changes.

Warning
  Do not use this function unless you know what Evas exactly works with "changed" state.

Parameters

  [in] | obj | The object.

References evas_canvas_nochange_push().

## evas_key_modifier_on()

EVAS_API void evas_key_modifier_on | ( | Evas_Canvas * | obj,
|  | const char * | keyname )

Enables or turns on programmatically the modifier key with name `keyname` for the default seat.

The effect will be as if the key was pressed for the whole time between this call and a matching evas_key_modifier_off().

See also evas_key_modifier_off, evas_seat_key_modifier_on, evas_seat_key_modifier_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the modifier to enable.

References evas_canvas_key_modifier_on().

## evas_seat_key_modifier_on()

EVAS_API void evas_seat_key_modifier_on | ( | Evas_Canvas * | obj,
|  | const char * | keyname,
|  | Evas_Device * | seat )

Enables or turns on programmatically the modifier key with name `keyname` for a given seat.

The effect will be as if the key was pressed for the whole time between this call and a matching evas_seat_key_modifier_off.

See also evas_key_modifier_off, evas_seat_key_modifier_on, evas_seat_key_modifier_off.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.
  [in] | seat | The seat to enable the modifier. A `null` seat repesents the default seat.

Since
  1.19

References evas_canvas_seat_key_modifier_on().

## evas_seat_key_modifier_off()

EVAS_API void evas_seat_key_modifier_off | ( | Evas_Canvas * | obj,
|  | const char * | keyname,
|  | Evas_Device * | seat )

Disables or turns off programmatically the modifier key with name `keyname` for a given seat.

See also evas_key_modifier_add, evas_key_modifier_get, evas_key_modifier_on, evas_seat_key_modifier_off, evas_seat_key_modifier_off, evas_key_modifier_is_set, evas_seat_key_modifier_is_set.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the lock to enable.
  [in] | seat | The seat to disable the modifier. A `null` seat repesents the default seat.

Since
  1.19

References evas_canvas_seat_key_modifier_off().

## evas_font_available_list()

EVAS_API Eina_List * evas_font_available_list | ( | const Evas_Canvas * | obj | ) |

List of available font descriptions known or found by this evas.

The list depends on Evas compile time configuration, such as fontconfig support, and the paths provided at runtime as explained in Font Path Functions.

Parameters

  [in] | obj | The object.

Returns
  A newly allocated list of strings. Do not change the strings. Be sure to call evas_font_available_list_free after you're done.

References evas_canvas_font_available_list().

## evas_object_name_find()

EVAS_API Efl_Canvas_Object * evas_object_name_find | ( | const Evas_Canvas * | obj,
|  | const char * | name )

Retrieves the object on the given evas with the given name.

This looks for the evas object given a name by evas_object_name_set. If the name is not unique canvas-wide, then which one of the many objects with that name is returned is undefined, so only use this if you can ensure the object name is unique.

Parameters

  [in] | obj | The object.
  [in] | name | The given name.

Returns
  If successful, the Evas object with the given name. Otherwise, `null`.

References evas_canvas_object_name_find().

Referenced by edje_evas_global_perspective_get(), and edje_perspective_global_set().

## evas_font_path_append()

EVAS_API void evas_font_path_append | ( | Evas_Canvas * | obj,
|  | const char * | path )

Appends a font path to the list of font paths used by the given evas.

Parameters

  [in] | obj | The object.
  [in] | path | The new font path.

References evas_canvas_font_path_append().

## evas_key_lock_del()

EVAS_API void evas_key_lock_del | ( | Evas_Canvas * | obj,
|  | const char * | keyname )

Removes the `keyname` key from the current list of lock keys on canvas `e`.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the key to remove from the locks list.

References evas_canvas_key_lock_del().

## evas_damage_rectangle_add()

EVAS_API void evas_damage_rectangle_add | ( | Evas_Canvas * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h )

Add a damage rectangle.

This is the function by which one tells evas that a part of the canvas has to be repainted.

Note
  All newly created Evas rectangles get the default color values of 255 255 255 255 (opaque white).

Parameters

  [in] | obj | The object.
  [in] | x | The rectangle's left position.
  [in] | y | The rectangle's top position.
  [in] | w | The rectangle's width.
  [in] | h | The rectangle's height.

References evas_canvas_damage_rectangle_add().

Referenced by ecore_evas_rotation_set(), and ecore_evas_rotation_with_resize_set().

## evas_font_path_list()

EVAS_API const Eina_List * evas_font_path_list | ( | const Evas_Canvas * | obj | ) |

Retrieves the list of font paths used by the given evas.

Parameters

  [in] | obj | The object.

Returns
  The list of font paths used.

References evas_canvas_font_path_list().

## evas_image_cache_reload()

EVAS_API void evas_image_cache_reload | ( | Evas_Canvas * | obj | ) |

Reload the image cache.

This function reloads the image cache of canvas.

Parameters

  [in] | obj | The object.

References evas_canvas_image_cache_reload().

## evas_coord_world_x_to_screen()

EVAS_API int evas_coord_world_x_to_screen | ( | const Evas_Canvas * | obj,
|  | int | x )

Convert/scale a canvas coordinate into output screen coordinates.

This function takes in a horizontal coordinate as the `x` parameter and converts it into output units, accounting for output size, viewport size and location, returning it as the function return value. If `e` is invalid, the results are undefined.

Parameters

  [in] | obj | The object.
  [in] | x | The canvas X coordinate.

Returns
  The output/screen coordinate translated to output coordinates.

References evas_canvas_coord_world_x_to_screen().

## evas_render_updates()

EVAS_API Eina_List * evas_render_updates | ( | Evas_Canvas * | obj | ) |

Force immediate renderization of the given Evas canvas.

This function forces an immediate renderization update of the given canvas `e`.

Note
  This is a very low level function, which most of Evas' users wouldn't care about. You might use it, for instance, to grab an Evas' canvas update regions and paint them back, using the canvas' pixmap, on a displaying system working below Evas.
  Evas is a stateful canvas. If no operations changing its state took place since the last rendering action, you won't see any changes and this call will be a no-op.

Parameters

  [in] | obj | The object.

Returns
  A newly allocated list of updated rectangles of the canvas (Eina_Rect structs). Free this list with evas_render_updates_free.

References evas_canvas_render_updates().

## evas_image_cache_flush()

EVAS_API void evas_image_cache_flush | ( | Evas_Canvas * | obj | ) |

Flush the image cache of the canvas.

This function flushes image cache of canvas.

Parameters

  [in] | obj | The object.

References evas_canvas_image_cache_flush().

Referenced by elm_cache_all_flush().

## evas_coord_screen_y_to_world()

EVAS_API int evas_coord_screen_y_to_world | ( | const Evas_Canvas * | obj,
|  | int | y )

Convert/scale an output screen coordinate into canvas coordinates.

This function takes in a vertical coordinate as the `y` parameter and converts it into canvas units, accounting for output size, viewport size and location, returning it as the function return value. If `e` is invalid, the results are undefined.

Parameters

  [in] | obj | The object.
  [in] | y | The screen/output y coordinate.

Returns
  The screen coordinate translated to canvas unit coordinates.

References evas_canvas_coord_screen_y_to_world().

## evas_key_modifier_del()

EVAS_API void evas_key_modifier_del | ( | Evas_Canvas * | obj,
|  | const char * | keyname )

Removes the `keyname` key from the current list of modifier keys on canvas `e`.

See also evas_key_modifier_add.

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the key to remove from the modifiers list.

References evas_canvas_key_modifier_del().

## evas_obscured_rectangle_add()

EVAS_API void evas_obscured_rectangle_add | ( | Evas_Canvas * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h )

Add an "obscured region" to an Evas canvas.

This is the function by which one tells an Evas canvas that a part of it must not be repainted. The region must be rectangular and its coordinates inside the canvas viewport are passed in the call. After this call, the region specified won't participate in any form in Evas' calculations and actions during its rendering updates, having its displaying content frozen as it was just after this function took place.

We call it "obscured region" because the most common use case for this rendering (partial) freeze is something else (most probably other canvas) being on top of the specified rectangular region, thus shading it completely from the user's final scene in a display. To avoid unnecessary processing, one should indicate to the obscured canvas not to bother about the non-important area.

The majority of users won't have to worry about this function, as they'll be using just one canvas in their applications, with nothing inset or on top of it in any form.

To make this region one that has to be repainted again, call the function evas_obscured_clear.

Note
  This is a very low level function, which most of Evas' users wouldn't care about.
  This function does not flag the canvas as having its state changed. If you want to re-render it afterwards expecting new contents, you have to add "damage" regions yourself (see evas_damage_rectangle_add).

Parameters

  [in] | obj | The object.
  [in] | x | The rectangle's top left corner's horizontal coordinate.
  [in] | y | The rectangle's top left corner's vertical coordinate.
  [in] | w | The rectangle's width.
  [in] | h | The rectangle's height.

References evas_canvas_obscured_rectangle_add().

## evas_render_dump()

EVAS_API void evas_render_dump | ( | Evas_Canvas * | obj | ) |

Make the canvas discard as much data as possible used by the engine at runtime.

This function will unload images, delete textures and much more where possible. You may also want to call evas_render_idle_flush immediately prior to this to perhaps discard a little more, though this function should implicitly delete most of what evas_render_idle_flush might discard too.

Parameters

  [in] | obj | The object.

References evas_canvas_render_dump().

## evas_font_path_prepend()

EVAS_API void evas_font_path_prepend | ( | Evas_Canvas * | obj,
|  | const char * | path )

Prepends a font path to the list of font paths used by the given evas.

Parameters

  [in] | obj | The object.
  [in] | path | The new font path.

References evas_canvas_font_path_prepend().

## evas_obscured_clear()

EVAS_API void evas_obscured_clear | ( | Evas_Canvas * | obj | ) |

Remove all "obscured regions" from an Evas canvas.

This function removes all the rectangles from the obscured regions list of the canvas `e`. It takes obscured areas added with evas_obscured_rectangle_add and make them again a regions that have to be repainted on rendering updates.

Note
  This is a very low level function, which most of Evas' users wouldn't care about.
  This function does not flag the canvas as having its state changed. If you want to re-render it afterwards expecting new contents, you have to add "damage" regions yourself (see evas_damage_rectangle_add).

Parameters

  [in] | obj | The object.

References evas_canvas_obscured_clear().

## evas_coord_screen_x_to_world()

EVAS_API int evas_coord_screen_x_to_world | ( | const Evas_Canvas * | obj,
|  | int | x )

Convert/scale an output screen coordinate into canvas coordinates.

This function takes in a horizontal coordinate as the `x` parameter and converts it into canvas units, accounting for output size, viewport size and location, returning it as the function return value. If `e` is invalid, the results are undefined.

Parameters

  [in] | obj | The object.
  [in] | x | The screen/output x coordinate.

Returns
  The screen coordinate translated to canvas unit coordinates.

References evas_canvas_coord_screen_x_to_world().

## evas_key_lock_add()

EVAS_API void evas_key_lock_add | ( | Evas_Canvas * | obj,
|  | const char * | keyname )

Adds the `keyname` key to the current list of lock keys.

Locks are keys like caps lock, num lock or scroll lock, i.e., keys which are meant to be pressed once – toggling a binary state which is bound to it – and thus altering the behavior of all subsequently pressed keys somehow, depending on its state. Evas is so that these keys can be defined by the user.

This allows custom locks to be added to the evas system at run time. It is then possible to set and unset lock keys programmatically for other parts of the program to check and act on. Programmers using Evas would check for lock keys on key event callbacks using evas_key_lock_is_set.

Note
  If the programmer instantiates the canvas by means of the ecore_evas_new() family of helper functions, Ecore will take care of registering on it all standard lock keys: "Caps_Lock", "Num_Lock", "Scroll_Lock".

Parameters

  [in] | obj | The object.
  [in] | keyname | The name of the key to add to the locks list.

References evas_canvas_key_lock_add().

Referenced by ecore_evas_buffer_allocfunc_new(), and ecore_evas_object_image_new().

## evas_render_idle_flush()

EVAS_API void evas_render_idle_flush | ( | Evas_Canvas * | obj | ) |

Make the canvas discard internally cached data used for rendering.

This function flushes the arrays of delete, active and render objects. Other things it may also discard are: shared memory segments, temporary scratch buffers, cached data to avoid re-compute of that data etc.

Parameters

  [in] | obj | The object.

References evas_canvas_render_idle_flush().

## evas_default_device_get()

EVAS_API Evas_Device * evas_default_device_get | ( | const Evas_Canvas * | obj,
|  | Evas_Device_Class | type )

Return the default device of a given type.

Note
  Currently EFL only creates a seat, mouse and keyboard.

Parameters

  [in] | obj | The object.
  [in] | type | The class of the default device to fetch.

Returns
  The default device or `null` on error.

Since
  1.19

References evas_canvas_default_device_get().

Referenced by ecore_evas_cursor_device_get(), ecore_evas_cursor_device_unset(), ecore_evas_focus_device_get(), and ecore_evas_pointer_device_xy_get().

## evas_coord_world_y_to_screen()

EVAS_API int evas_coord_world_y_to_screen | ( | const Evas_Canvas * | obj,
|  | int | y )

Convert/scale a canvas coordinate into output screen coordinates.

This function takes in a vertical coordinate as the `x` parameter and converts it into output units, accounting for output size, viewport size and location, returning it as the function return value. If `e` is invalid, the results are undefined.

Parameters

  [in] | obj | The object.
  [in] | y | The canvas y coordinate.

Returns
  The output/screen coordinate translated to output coordinates.

References evas_canvas_coord_world_y_to_screen().

## evas_render_updates_free()

EVAS_API void evas_render_updates_free | ( | Eina_List * | updates | ) |

Free the rectangles returned by evas_render_updates().

Parameters

  updates | The list of updated rectangles of the canvas.

This function removes the region from the render updates list. It makes the region doesn't be render updated anymore.

See also
  evas_render_updates() for an example

References EINA_LIST_FREE, and eina_rectangle_free().

## evas_new()

EVAS_API Evas * evas_new | ( | void |  | ) |

Creates a new empty evas.

Note that before you can use the evas, you will to at a minimum:

- Set its render method with evas_output_method_set .
- Set its viewport size with evas_output_viewport_set .
- Set its size of the canvas with evas_output_size_set .
- Ensure that the render engine is given the correct settings with evas_engine_info_set .

This function should only fail if the memory allocation fails

Note
  this function is very low level. Instead of using it directly, consider using the high level functions in Ecore_Evas wrapper/helper set of functions such as `ecore_evas_new()`. See Ecore.

Attention
  it is recommended that one calls evas_init() before creating new canvas.

Returns
  A new uninitialised Evas canvas on success. Otherwise, `NULL`.

References EVAS_CANVAS_CLASS.

Referenced by ecore_evas_object_image_new().

## evas_free()

EVAS_API void evas_free | ( | Evas * | e | ) |

Frees the given evas and any objects created on it.

Any objects with 'free' callbacks will have those callbacks called in this function.

Parameters

  e | The given evas.

## evas_engine_info_set()

EVAS_API Eina_Bool evas_engine_info_set | ( | Evas * | obj,
|  | Evas_Engine_Info * | info )

Applies the engine settings for the given evas from the given `Evas_Engine_Info` structure.

To get the Evas_Engine_Info structure to use, call evas_engine_info_get. Do not try to obtain a pointer to an `Evas_Engine_Info` structure in any other way.

You will need to call this function at least once before you can create objects on an evas or render that evas. Some engines allow their settings to be changed more than once.

Once called, the `info` pointer should be considered invalid.

Parameters

  [in] | info | The pointer to the engine info to use.

Returns
  `true` if no error occurred, `false` otherwise.

References EINA_FALSE, and EVAS_CANVAS_CLASS.

Referenced by ecore_evas_buffer_allocfunc_new(), and ecore_evas_object_image_new().

## evas_engine_info_get()

EVAS_API Evas_Engine_Info * evas_engine_info_get | ( | const Evas * | obj | ) |

Retrieves the current render engine info struct from the given evas.

The returned structure is publicly modifiable. The contents are valid until either evas_engine_info_set or evas_render are called.

This structure does not need to be freed by the caller.

Returns
  The pointer to the engine info to use.

References EINA_TRUE, and EVAS_CANVAS_CLASS.

Referenced by ecore_evas_buffer_allocfunc_new(), and ecore_evas_object_image_new().

## evas_key_modifier_get()

EVAS_API const Evas_Modifier * evas_key_modifier_get | ( | const Evas * | obj | ) |

Returns a handle to the list of modifier keys registered in the canvas `e`.

This is required to check for which modifiers are set at a given time with the evas_key_modifier_is_set function.

See also evas_key_modifier_add, evas_key_modifier_del, evas_key_modifier_on, evas_key_modifier_off, evas_seat_key_modifier_on, evas_seat_key_modifier_off.

Returns
  An Evas_Modifier handle to query Evas' keys subsystem with evas_key_modifier_is_set or evas_seat_key_modifier_is_set, or `null` on error.

## evas_key_modifier_mask_get()

EVAS_API Evas_Modifier_Mask evas_key_modifier_mask_get | ( | const Evas * | evas,
|  | const char * | keyname )

Creates a bit mask from the `keyname` modifier key.

Values returned from different calls to it may be ORed together, naturally.

This function is meant to be using in conjunction with evas_object_key_grab/@ref evas_object_key_ungrab. Go check their documentation for more information.

See also evas_key_modifier_add, evas_key_modifier_get, evas_key_modifier_on, evas_key_modifier_off, evas_seat_key_modifier_on, evas_seat_key_modifier_off, evas_key_modifier_is_set, evas_seat_key_modifier_is_set..

Parameters

  [in] | keyname | The name of the modifier key to create the mask for.

Returns
  The bit mask or 0 if the `keyname` key wasn't registered as a modifier for canvas `e`.

## evas_key_lock_get()

EVAS_API const Evas_Lock * evas_key_lock_get | ( | const Evas * | obj | ) |

Returns a handle to the list of lock keys registered in the canvas `e`.

This is required to check for which locks are set at a given time with the evas_key_lock_is_set function.

Returns
  An Evas_Lock handle to query Evas' keys subsystem with evas_key_lock_is_set or evas_seat_key_lock_is_set, or `null` on error.

## evas_pointer_inside_by_device_get()

EVAS_API Eina_Bool evas_pointer_inside_by_device_get | ( | const Evas * | obj,
|  | Efl_Input_Device * | dev )

Returns whether the mouse pointer is logically inside the canvas.

Parameters

  [in] | obj | The object.
  [in] | dev | The pointer device.

Returns
  `true` if the pointer is inside, `false` otherwise.

Since
  1.19

References EINA_FALSE.

## evas_pointer_inside_get()

EVAS_API Eina_Bool evas_pointer_inside_get | ( | const Evas * | obj | ) |

Returns whether the default mouse pointer is logically inside the canvas.

When this function is called it will return a value of either `false` or `true`, depending on if event_feed_mouse_in or event_feed_mouse_out have been called to feed in a mouse enter event into the canvas.

A return value of `true` indicates the mouse is logically inside the canvas, and `false` implies it is logically outside the canvas.

A canvas begins with the mouse being assumed outside ($false).

If `e` is not a valid canvas, the return value is undefined.

Parameters

  [in] | obj | The object.

Returns
  `true` if the mouse pointer is inside the canvas, `false` otherwise

References EINA_FALSE.

## evas_font_hinting_can_hint()

EVAS_API Eina_Bool evas_font_hinting_can_hint | ( | const Evas * | e,
|  | Evas_Font_Hinting_Flags | hinting )

Checks if the font hinting is supported by the given evas.

One of EVAS_FONT_HINTING_NONE, EVAS_FONT_HINTING_AUTO, EVAS_FONT_HINTING_BYTECODE.

Parameters

  [in] | hinting | The hinting to use.

Returns
  `true` if it is supported, `false` otherwise.

References EINA_FALSE.

## evas_objects_at_xy_get()

EVAS_API Eina_List * evas_objects_at_xy_get | ( | Eo * | eo_e,
|  | int | x,
|  | int | y,
|  | Eina_Bool | include_pass_events_objects,
|  | Eina_Bool | include_hidden_objects )

Retrieve a list of objects lying over a given position in a canvas.

This function will traverse all the layers of the given canvas, from top to bottom, querying for objects with areas covering the given position. The user can remove from query objects which are hidden and/or which are set to pass events.

Warning
  This function will skip objects parented by smart objects, acting only on the ones at the "top level", with regard to object parenting.

Parameters

  [in] | obj | The object.
  [in] | x | The pixel position.
  [in] | y | The pixel position.
  [in] | include_pass_events_objects | Boolean flag to include or not objects which pass events in this calculation.
  [in] | include_hidden_objects | Boolean flag to include or not hidden objects in this calculation.

Returns
  The list of objects that are over the given position in `e`.

References EVAS_CANVAS_CLASS.

## evas_object_top_at_xy_get()

EVAS_API Evas_Object * evas_object_top_at_xy_get | ( | Eo * | eo_e,
|  | Evas_Coord | x,
|  | Evas_Coord | y,
|  | Eina_Bool | include_pass_events_objects,
|  | Eina_Bool | include_hidden_objects )

Retrieve the object stacked at the top of a given position in a canvas.

This function will traverse all the layers of the given canvas, from top to bottom, querying for objects with areas covering the given position. The user can remove from the query objects which are hidden and/or which are set to pass events.

Warning
  This function will skip objects parented by smart objects, acting only on the ones at the "top level", with regard to object parenting.

Parameters

  [in] | obj | The object.
  [in] | x | The pixel position.
  [in] | y | The pixel position.
  [in] | include_pass_events_objects | Boolean flag to include or not objects which pass events in this calculation.
  [in] | include_hidden_objects | Boolean flag to include or not hidden objects in this calculation.

Returns
  The Evas object that is over all other objects at the given position.

## evas_objects_in_rectangle_get()

EVAS_API Eina_List * evas_objects_in_rectangle_get | ( | const Eo * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | Eina_Bool | include_pass_events_objects,
|  | Eina_Bool | include_hidden_objects )

Get all objects in the given rectangle.

Parameters

  [in] | obj | The object.
  [in] | x | X coordinate
  [in] | y | Y coordinate
  [in] | w | Width
  [in] | h | Height
  [in] | include_pass_events_objects | `true` if the list should include objects which pass events
  [in] | include_hidden_objects | `true` if the list should include hidden objects

Returns
  List of objects

## evas_object_top_in_rectangle_get()

EVAS_API Evas_Object * evas_object_top_in_rectangle_get | ( | const Eo * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | Eina_Bool | include_pass_events_objects,
|  | Eina_Bool | include_hidden_objects )

Retrieve the Evas object stacked at the top of a given rectangular region in a canvas.

This function will traverse all the layers of the given canvas, from top to bottom, querying for objects with areas overlapping with the given rectangular region inside `e`. The user can remove from the query objects which are hidden and/or which are set to pass events.

Warning
  This function will skip objects parented by smart objects, acting only on the ones at the "top level", with regard to object parenting.

Parameters

  [in] | obj | The object.
  [in] | x | The top left corner's horizontal coordinate for the rectangular region.
  [in] | y | The top left corner's vertical coordinate for the rectangular region.
  [in] | w | The width of the rectangular region.
  [in] | h | The height of the rectangular region.
  [in] | include_pass_events_objects | Boolean flag to include or not objects which pass events in this calculation.
  [in] | include_hidden_objects | Boolean flag to include or not hidden objects in this calculation.

Returns
  The Evas object that is over all other objects at the given rectangular region.

References EINA_RECT.

## evas_output_framespace_set()

EVAS_API void evas_output_framespace_set | ( | Evas * | e,
|  | Evas_Coord | x,
|  | Evas_Coord | y,
|  | Evas_Coord | w,
|  | Evas_Coord | h )

Sets the output framespace size of the render engine of the given evas.

The framespace size is used in the Wayland engines to denote space in the viewport which is occupied by the window frame. This is mainly used in ecore_evas to draw borders.

The units used for `w` and `h` depend on the engine used by the evas.

Parameters

  [in] | x | The left coordinate in output units, usually pixels.
  [in] | y | The top coordinate in output units, usually pixels.
  [in] | w | The width in output units, usually pixels.
  [in] | h | The height in output units, usually pixels.

Since
  1.1

References EVAS_CANVAS_CLASS.

## evas_output_framespace_get()

EVAS_API void evas_output_framespace_get | ( | const Evas * | e,
|  | Evas_Coord * | x,
|  | Evas_Coord * | y,
|  | Evas_Coord * | w,
|  | Evas_Coord * | h )

Get the render engine's output framespace coordinates in canvas units.

Parameters

  [out] | x | The left coordinate in output units, usually pixels.
  [out] | y | The top coordinate in output units, usually pixels.
  [out] | w | The width in output units, usually pixels.
  [out] | h | The height in output units, usually pixels.

Since
  1.1

References EVAS_CANVAS_CLASS.

## evas_output_viewport_set()

EVAS_API void evas_output_viewport_set | ( | Evas * | e,
|  | Evas_Coord | x,
|  | Evas_Coord | y,
|  | Evas_Coord | w,
|  | Evas_Coord | h )

Sets the output viewport of the given evas in evas units.

The output viewport is the area of the evas that will be visible to the viewer. The viewport will be stretched to fit the output target of the evas when rendering is performed.

Note
  The coordinate values do not have to map 1-to-1 with the output target. However, it is generally advised that it is done for ease of use.

Parameters

  [in] | x | The top-left corner x value of the viewport.
  [in] | y | The top-left corner y value of the viewport.
  [in] | w | The width of the viewport. Must be greater than 0.
  [in] | h | The height of the viewport. Must be greater than 0.

References ERR, EVAS_CALLBACK_CANVAS_VIEWPORT_RESIZE, and EVAS_CANVAS_CLASS.

Referenced by ecore_evas_object_image_new().

## evas_output_viewport_get()

EVAS_API void evas_output_viewport_get | ( | const Evas * | e,
|  | Evas_Coord * | x,
|  | Evas_Coord * | y,
|  | Evas_Coord * | w,
|  | Evas_Coord * | h )

Get the render engine's output viewport coordinates in canvas units.

Calling this function writes the current canvas output viewport size and location values into the variables pointed to by `x`, `y`, `w` and `h`. On success the variables have the output location and size values written to them in canvas units. Any of `x`, `y`, `w` or `h` that are `null` will not be written to. If `e` is invalid, the results are undefined.

Parameters

  [out] | x | The top-left corner x value of the viewport.
  [out] | y | The top-left corner y value of the viewport.
  [out] | w | The width of the viewport. Must be greater than 0.
  [out] | h | The height of the viewport. Must be greater than 0.

References EVAS_CANVAS_CLASS.

Referenced by edje_perspective_new().

## evas_output_method_set()

EVAS_API void evas_output_method_set | ( | Evas * | e,
|  | int | render_method )

Sets the output engine for the given evas.

Once the output engine for an evas is set, any attempt to change it will be ignored. The value for `render_method` can be found using evas_render_method_lookup.

Note
  it is mandatory that one calls evas_init before setting the output method.

Parameters

  [in] | render_method | The numeric engine value to use.

References eina_inlist_append(), EINA_INLIST_GET, EINA_LIST_FOREACH, eina_streq(), EVAS_CANVAS_CLASS, evas_device_add_full(), EVAS_DEVICE_CLASS_KEYBOARD, EVAS_DEVICE_CLASS_MOUSE, EVAS_DEVICE_CLASS_SEAT, evas_device_seat_id_set(), and EVAS_DEVICE_SUBCLASS_NONE.

Referenced by ecore_evas_buffer_allocfunc_new(), and ecore_evas_object_image_new().

## evas_output_method_get()

EVAS_API int evas_output_method_get | ( | const Evas * | e | ) |

Retrieves the number of the output engine used for the given evas.

Returns
  The numeric engine value to use.

References EVAS_CANVAS_CLASS.

## evas_output_size_set()

EVAS_API void evas_output_size_set | ( | Evas * | e,
|  | int | w,
|  | int | h )

Sets the output size of the render engine of the given evas.

The evas will render to a rectangle of the given size once this function is called. The output size is independent of the viewport size. The viewport will be stretched to fill the given rectangle.

The units used for `w` and `h` depend on the engine used by the evas.

Parameters

  [in] | w | The width in output units, usually pixels.
  [in] | h | The height in output units, usually pixels.

References EVAS_CANVAS_CLASS.

Referenced by ecore_evas_object_image_new().

## evas_output_size_get()

EVAS_API void evas_output_size_get | ( | const Evas * | e,
|  | int * | w,
|  | int * | h )

Retrieve the output size of the render engine of the given evas.

The output size is given in whatever the output units are for the engine.

If either `w` or `h` is `null`, then it is ignored. If `e` is invalid, the returned results are undefined.

Parameters

  [out] | w | The width in output units, usually pixels.
  [out] | h | The height in output units, usually pixels.

References EVAS_CANVAS_CLASS.